import { h, Host } from "@stencil/core";
import { Icon } from "../icons";
import { getNonExplicitAttributes } from "../../../utils/utils";
import "@phosphor-icons/webcomponents/dist/icons/PhArrowBendDownLeft.mjs";
// TODO: consider renaming this component
/**
 * The orama-chat-button component is used to render a button element that will trigger the chat.
 */
export class OramaChatButton {
    constructor() {
        this.active = false;
        this.highlight = false;
    }
    highlightButton() {
        if (this.active && !this.highlight) {
            this.highlight = true;
        }
    }
    render() {
        const declaredProps = ['label', 'onClick', 'class'];
        const buttonProps = getNonExplicitAttributes(this.el, declaredProps);
        return (h(Host, { key: 'cc45b1355726ff5bf65b39f4243f6f0d227d0c80', class: this.class }, h("button", Object.assign({ key: '4a312f0e559412dee000149b4f3cf74cfe858c0e', class: {
                'chat-button': true,
                'is-active': this.active,
                'is-highlighted': this.highlight,
            } }, buttonProps, { type: "button" }), h("span", { key: '9a10019c4b275d05978ecad9abcffb058d782943', class: "icon-star" }, h(Icon, { key: '82edfc1787227fb15f3fefedecf57e2a0e74d8b3', name: "star", size: 16 })), h("span", { key: '13e4d54e9296f513735f6081caaf060cc9511905', class: "button-label" }, this.label), h("span", { key: '3c98e473b7b88034a316590bae6de3d1c1ca4dd4', class: "icon-enter" }, h("ph-arrow-bend-down-left", { key: '36f9ce444b33abaef5cfdf81d0d0d2b199f8590f', size: 12 })))));
    }
    static get is() { return "orama-chat-button"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["orama-chat-button.scss"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["orama-chat-button.css"]
        };
    }
    static get properties() {
        return {
            "label": {
                "type": "string",
                "attribute": "label",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "active": {
                "type": "boolean",
                "attribute": "active",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "false"
            },
            "highlight": {
                "type": "boolean",
                "attribute": "highlight",
                "mutable": true,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "false"
            },
            "class": {
                "type": "string",
                "attribute": "class",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            }
        };
    }
    static get elementRef() { return "el"; }
    static get watchers() {
        return [{
                "propName": "active",
                "methodName": "highlightButton"
            }, {
                "propName": "highlight",
                "methodName": "highlightButton"
            }];
    }
}
//# sourceMappingURL=orama-chat-button.js.map
