var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Host, h } from "@stencil/core";
import "@phosphor-icons/webcomponents/dist/icons/PhCopy.mjs";
import "@phosphor-icons/webcomponents/dist/icons/PhArrowsClockwise.mjs";
import "@phosphor-icons/webcomponents/dist/icons/PhThumbsDown.mjs";
import "@phosphor-icons/webcomponents/dist/icons/PhWarning.mjs";
import { copyToClipboard } from "../../../../utils/utils";
import { TAnswerStatus, } from "../../../../types/index";
import { Store } from "../../../../StoreDecorator";
export class OramaChatAssistentMessage {
    constructor() {
        this.isCopied = false;
        this.handleCopyToClipboard = () => {
            this.isCopied = true;
            setTimeout(() => (this.isCopied = false), 1000);
            copyToClipboard(this.interaction.response);
        };
        this.isDisliked = false;
        this.handleDislikeMessage = () => {
            // todo: replace with actual dislike logic
            this.isDisliked = !this.isDisliked;
        };
        this.handleRetryMessage = () => {
            var _a;
            (_a = this.chatStore.state.chatService) === null || _a === void 0 ? void 0 : _a.regenerateLatest();
        };
    }
    render() {
        if (this.interaction.status === 'loading') {
            return (h("div", { class: "message-wrapper" }, h("orama-dots-loader", null)));
        }
        if (this.interaction.status === 'error') {
            return (h("div", { class: "message-error" }, h("ph-warning", { size: 16 }), h("orama-text", { styledAs: "span", inactive: true }, "An error occurred while trying to search. Please try again.")));
        }
        return (h(Host, null, h("orama-sources", { sources: this.interaction.sources, sourceBaseURL: this.chatStore.state.sourceBaseURL, linksRel: this.chatStore.state.linksRel, linksTarget: this.chatStore.state.linksTarget }), h("div", { class: "message-wrapper" }, !this.interaction.response ? (h("orama-dots-loader", null)) : (h("orama-markdown", { content: this.interaction.response, chatMarkdownLinkTitle: this.chatMarkdownLinkTitle, chatMarkdownLinkHref: this.chatMarkdownLinkHref })), h("div", { class: { 'message-actions': true, hidden: this.interaction.status !== TAnswerStatus.done } }, this.interaction.latest && (h("orama-button", { type: "button", variant: "icon", onClick: this.handleRetryMessage, onKeyDown: this.handleRetryMessage, "aria-label": "Retry message" }, h("ph-arrows-clockwise", { size: "16px" }))), h("orama-button", { type: "button", variant: "icon", onClick: this.handleCopyToClipboard, onKeyDown: this.handleCopyToClipboard, withTooltip: this.isCopied ? 'Copied!' : undefined, "aria-label": "Copy message" }, h("ph-copy", { size: "16px" })), h("orama-button", { type: "button", variant: "icon", onClick: this.handleDislikeMessage, onKeyDown: this.handleDislikeMessage, "aria-label": "Dislike message" }, this.isDisliked ? h("ph-thumbs-down", { weight: "fill", size: "16px" }) : h("ph-thumbs-down", { size: "16px" }))))));
    }
    static get is() { return "orama-chat-assistent-message"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["orama-chat-assistent-message.scss"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["orama-chat-assistent-message.css"]
        };
    }
    static get properties() {
        return {
            "interaction": {
                "type": "unknown",
                "attribute": "interaction",
                "mutable": false,
                "complexType": {
                    "original": "TChatInteraction",
                    "resolved": "{ query: string; response?: string; sources?: SourceItem[]; latest?: boolean; status: TAnswerStatus; interactionId?: string; relatedQueries?: string[]; }",
                    "references": {
                        "TChatInteraction": {
                            "location": "import",
                            "path": "@/types",
                            "id": "src/types/index.ts::TChatInteraction"
                        }
                    }
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            },
            "chatMarkdownLinkTitle": {
                "type": "unknown",
                "attribute": "chat-markdown-link-title",
                "mutable": false,
                "complexType": {
                    "original": "ChatMarkdownLinkTitle",
                    "resolved": "({ text, href }: { text: string; href: string; }) => string",
                    "references": {
                        "ChatMarkdownLinkTitle": {
                            "location": "import",
                            "path": "@/types",
                            "id": "src/types/index.ts::ChatMarkdownLinkTitle"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            },
            "chatMarkdownLinkHref": {
                "type": "unknown",
                "attribute": "chat-markdown-link-href",
                "mutable": false,
                "complexType": {
                    "original": "ChatMarkdownLinkHref",
                    "resolved": "({ text, href }: { text: string; href: string; }) => string",
                    "references": {
                        "ChatMarkdownLinkHref": {
                            "location": "import",
                            "path": "@/types",
                            "id": "src/types/index.ts::ChatMarkdownLinkHref"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            },
            "chatMarkdownLinkTarget": {
                "type": "unknown",
                "attribute": "chat-markdown-link-target",
                "mutable": false,
                "complexType": {
                    "original": "ChatMarkdownLinkTarget",
                    "resolved": "({ text, href }: { text: string; href: string; }) => string",
                    "references": {
                        "ChatMarkdownLinkTarget": {
                            "location": "import",
                            "path": "@/types",
                            "id": "src/types/index.ts::ChatMarkdownLinkTarget"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            }
        };
    }
    static get states() {
        return {
            "isCopied": {},
            "isDisliked": {}
        };
    }
    static get elementRef() { return "htmlElement"; }
}
__decorate([
    Store('chat')
], OramaChatAssistentMessage.prototype, "chatStore", void 0);
//# sourceMappingURL=orama-chat-assistent-message.js.map
