var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Host, h } from "@stencil/core";
import { Store } from "../../../StoreDecorator";
export class OramaChatMessagesContainer {
    constructor() {
        this.latestInteractionMinHeight = 0;
        // TODO: I'm not sure about having this here as we're breaking our rule of maintain service access only to the very top level component
        this.onSuggestionClick = (suggestion) => {
            var _a;
            (_a = this.chatStore.state.chatService) === null || _a === void 0 ? void 0 : _a.sendQuestion(suggestion, undefined, undefined, {
                onAnswerGeneratedCallback: (onAnswerGeneratedCallbackProps) => this.answerGenerated.emit(onAnswerGeneratedCallbackProps),
            });
        };
        this.resizeObserver = new ResizeObserver((entries) => {
            // FIXME: We are removing the margin with a constant value. It should be calculated
            this.latestInteractionMinHeight = entries[0].target.clientHeight - 32;
        });
    }
    componentDidLoad() {
        // FIXME: We should get the element in another way. I tried findById or class and it was not working.
        // probable something related to the shadow dom
        const messagesWrapperElement = this.el.parentElement.parentElement;
        this.resizeObserver.observe(messagesWrapperElement);
    }
    render() {
        return (h(Host, { key: '16faa4d865e3c1c475a099c2a537c9fcd356bf7b' }, h("div", { key: '4fc29b18a434697d629e1327cffdce84d56a21c2', class: "messages-container" }, this.interactions.map((interaction, interactionIndex) => {
            var _a;
            return (h("div", { key: interaction.interactionId, class: "interaction-wrapper",
                // Hack to put the message on top when auto scrolling
                style: {
                    minHeight: this.interactions.length > 1 && interactionIndex === this.interactions.length - 1
                        ? `${this.latestInteractionMinHeight}px`
                        : '0px',
                } }, h("orama-chat-user-message", { interaction: Object.assign({}, interaction) }), h("orama-chat-assistent-message", { interaction: Object.assign({}, interaction), chatMarkdownLinkTitle: this.chatMarkdownLinkTitle, chatMarkdownLinkHref: this.chatMarkdownLinkHref }), interaction.latest && interaction.status === 'done' && !!((_a = interaction.relatedQueries) === null || _a === void 0 ? void 0 : _a.length) && (h("div", { class: "suggestions-wrapper" }, h("orama-suggestions", { as: "chips", suggestions: interaction.relatedQueries, suggestionClicked: this.onSuggestionClick })))));
        }))));
    }
    static get is() { return "orama-chat-messages-container"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["orama-chat-messages-container.scss"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["orama-chat-messages-container.css"]
        };
    }
    static get properties() {
        return {
            "interactions": {
                "type": "unknown",
                "attribute": "interactions",
                "mutable": false,
                "complexType": {
                    "original": "TChatInteraction[]",
                    "resolved": "TChatInteraction[]",
                    "references": {
                        "TChatInteraction": {
                            "location": "import",
                            "path": "@/types",
                            "id": "src/types/index.ts::TChatInteraction"
                        }
                    }
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            },
            "chatMarkdownLinkTitle": {
                "type": "unknown",
                "attribute": "chat-markdown-link-title",
                "mutable": false,
                "complexType": {
                    "original": "ChatMarkdownLinkTitle",
                    "resolved": "({ text, href }: { text: string; href: string; }) => string",
                    "references": {
                        "ChatMarkdownLinkTitle": {
                            "location": "import",
                            "path": "@/types",
                            "id": "src/types/index.ts::ChatMarkdownLinkTitle"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            },
            "chatMarkdownLinkHref": {
                "type": "unknown",
                "attribute": "chat-markdown-link-href",
                "mutable": false,
                "complexType": {
                    "original": "ChatMarkdownLinkHref",
                    "resolved": "({ text, href }: { text: string; href: string; }) => string",
                    "references": {
                        "ChatMarkdownLinkHref": {
                            "location": "import",
                            "path": "@/types",
                            "id": "src/types/index.ts::ChatMarkdownLinkHref"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            },
            "chatMarkdownLinkTarget": {
                "type": "unknown",
                "attribute": "chat-markdown-link-target",
                "mutable": false,
                "complexType": {
                    "original": "ChatMarkdownLinkTarget",
                    "resolved": "({ text, href }: { text: string; href: string; }) => string",
                    "references": {
                        "ChatMarkdownLinkTarget": {
                            "location": "import",
                            "path": "@/types",
                            "id": "src/types/index.ts::ChatMarkdownLinkTarget"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            }
        };
    }
    static get states() {
        return {
            "latestInteractionMinHeight": {}
        };
    }
    static get events() {
        return [{
                "method": "answerGenerated",
                "name": "answerGenerated",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "complexType": {
                    "original": "OnAnswerGeneratedCallbackProps",
                    "resolved": "{ askParams: AskParams; query: string; sources: Results<unknown>; answer: string; segment: string; trigger: string; }",
                    "references": {
                        "OnAnswerGeneratedCallbackProps": {
                            "location": "import",
                            "path": "@/types",
                            "id": "src/types/index.ts::OnAnswerGeneratedCallbackProps"
                        }
                    }
                }
            }];
    }
    static get elementRef() { return "el"; }
}
__decorate([
    Store('chat')
], OramaChatMessagesContainer.prototype, "chatStore", void 0);
//# sourceMappingURL=orama-chat-messages-container.js.map
