var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Fragment, Host, h } from "@stencil/core";
import "@phosphor-icons/webcomponents/dist/icons/PhClock.mjs";
import "@phosphor-icons/webcomponents/dist/icons/PhPlus.mjs";
import "@phosphor-icons/webcomponents/dist/icons/PhCaretLeft.mjs";
import { Store } from "../../../StoreDecorator";
export class OramaNavigationBar {
    constructor() {
        this.showBackButton = true;
        this.showChatActions = false;
        // TODO: maybe better to make this component context agnostic
        this.handleStartNewChat = () => {
            var _a;
            (_a = this.chatStore.state.chatService) === null || _a === void 0 ? void 0 : _a.resetChat();
        };
    }
    render() {
        return (h(Host, { key: '676f6e8004de45bc7e70a38534c694c57b2c5068' }, h("div", { key: '036c53deef2f5fa0785f677d7aec3cb6fcc47a39', class: "corner-section start" }, this.showBackButton ? (h(Fragment, null, h("orama-button", { type: "button", variant: "icon", "aria-label": "Exit", onClick: this.handleClose, onKeyDown: this.handleClose }, h("ph-caret-left", { size: "20px" })))) : (h("div", { class: "spacer" }))), h("div", { key: '2dd271a6f0742652bb3480cb7996f46bd3a64bb5', class: "corner-section center" }, h("orama-toggler", { key: '80ecf7005825e985ed5e86a12c5912d6e104c238' })), h("div", { key: 'c00c10b04bffa9e7bbae61f27d0fc6e483b66e8a', class: "corner-section end" }, this.showChatActions ? (h(Fragment, null, h("orama-button", { type: "button", variant: "icon", "aria-label": "Start new chat", onClick: this.handleStartNewChat, onKeyDown: this.handleStartNewChat }, h("ph-plus", { size: "20px" })))) : (h("div", { class: "spacer" })))));
    }
    static get is() { return "orama-navigation-bar"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["orama-navigation-bar.scss"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["orama-navigation-bar.css"]
        };
    }
    static get properties() {
        return {
            "handleClose": {
                "type": "unknown",
                "attribute": "handle-close",
                "mutable": false,
                "complexType": {
                    "original": "() => void",
                    "resolved": "() => void",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            },
            "showBackButton": {
                "type": "boolean",
                "attribute": "show-back-button",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "true"
            },
            "showChatActions": {
                "type": "boolean",
                "attribute": "show-chat-actions",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "false"
            }
        };
    }
}
__decorate([
    Store('chat')
], OramaNavigationBar.prototype, "chatStore", void 0);
//# sourceMappingURL=orama-navigation-bar.js.map
