var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Host, h } from "@stencil/core";
import { Store } from "../../../StoreDecorator";
import { getText as getTextUtil } from "../../../utils/textDictionary";
export class OramaSearch {
    constructor() {
        this.placeholder = 'Search...';
        this.focusInput = false;
        this.suggestions = [];
        this.disableChat = false;
        this.highlightTitle = false;
        this.highlightDescription = false;
        this.selectedFacet = '';
        this.handleSubmit = (e) => {
            e.preventDefault();
            if (this.disableChat) {
                return;
            }
            const chatButton = this.el.querySelector('orama-chat-button');
            chatButton === null || chatButton === void 0 ? void 0 : chatButton.click();
        };
    }
    /**
     * Gets the text for a specific key from the dictionary prop.
     * Prioritizes direct props (placeholder) for backward compatibility,
     * then falls back to the dictionary prop, and finally to the defaultTextDictionary.
     *
     * @param key - The key to get the text for
     * @returns The text for the specified key
     */
    getText(key) {
        // Create a map of direct props for backward compatibility
        const directProps = {
            searchPlaceholder: this.placeholder,
        };
        return getTextUtil(key, this.dictionary, directProps);
    }
    doSearch() {
        this.searchStore.state.searchService.search(this.globalStore.state.currentTerm, this.selectedFacet, {
            onSearchCompletedCallback: (onSearchCompletedCallbackProps) => {
                this.searchCompleted.emit(onSearchCompletedCallbackProps);
            },
        });
    }
    render() {
        var _a;
        return (h(Host, { key: '688c8af1ca2951057a901d4e5d93f44877f6e73b' }, h("form", { key: 'f08750150118e1417d817ead3024011a7dfa6d77', onSubmit: this.handleSubmit, class: "search-form" }, h("orama-input", { key: 'a173662d45226aa2e36f3ed12f5c3792d1f4aa86', "focus-on-arrow-nav": true, autoFocus: this.focusInput, type: "search", onInput: (e) => {
                const target = e.target;
                this.globalStore.state.currentTerm = target.value;
                this.doSearch();
            }, value: this.globalStore.state.currentTerm, size: "large", labelForScreenReaders: this.getText('searchPlaceholder'), placeholder: this.getText('searchPlaceholder') }), h("slot", { key: '64b40b9655e4bd2842800d0ca33e6cdaabf019cc', name: "summary" })), h("div", { key: '98f8fd718183e5436a2d42eabf8313d5b071be32', class: "result-wrapper" }, h("orama-facets", { key: '6dec4d3f30682444e46a18f3e31a6c77baf42f9c', facets: this.searchStore.state.facets, selectedFacet: this.selectedFacet, selectedFacetChanged: (facetName) => {
                this.selectedFacet = facetName;
                this.doSearch();
            } }), h("orama-search-results", { key: '7e8fe4f97b6882d503965c99044a4d5e46e649b7', suggestions: !((_a = this.globalStore.state.currentTerm) === null || _a === void 0 ? void 0 : _a.length) && !this.disableChat ? this.suggestions : [], setChatTerm: (term) => {
                var _a;
                this.globalStore.state.currentTask = 'chat';
                (_a = this.chatStore.state.chatService) === null || _a === void 0 ? void 0 : _a.sendQuestion(term, this.relatedQueries, undefined, {
                    onAnswerGeneratedCallback: (onAnswerGeneratedCallbackProps) => this.answerGenerated.emit(onAnswerGeneratedCallbackProps),
                });
            }, sourceBaseUrl: this.sourceBaseUrl, linksTarget: this.linksTarget, linksRel: this.linksRel, sections: this.searchStore.state.results, searchTerm: this.globalStore.state.currentTerm, highlightTitle: this.highlightTitle, highlightDescription: this.highlightDescription, loading: this.searchStore.state.loading, error: this.searchStore.state.error, dictionary: this.dictionary }))));
    }
    static get is() { return "orama-search"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["orama-search.scss"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["orama-search.css"]
        };
    }
    static get properties() {
        return {
            "placeholder": {
                "type": "string",
                "attribute": "placeholder",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "'Search...'"
            },
            "focusInput": {
                "type": "boolean",
                "attribute": "focus-input",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "false"
            },
            "suggestions": {
                "type": "unknown",
                "attribute": "suggestions",
                "mutable": false,
                "complexType": {
                    "original": "string[]",
                    "resolved": "string[]",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "defaultValue": "[]"
            },
            "sourceBaseUrl": {
                "type": "string",
                "attribute": "source-base-url",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "linksTarget": {
                "type": "string",
                "attribute": "links-target",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "linksRel": {
                "type": "string",
                "attribute": "links-rel",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "disableChat": {
                "type": "boolean",
                "attribute": "disable-chat",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "false"
            },
            "relatedQueries": {
                "type": "number",
                "attribute": "related-queries",
                "mutable": false,
                "complexType": {
                    "original": "number",
                    "resolved": "number",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "highlightTitle": {
                "type": "boolean",
                "attribute": "highlight-title",
                "mutable": false,
                "complexType": {
                    "original": "HighlightOptions | false",
                    "resolved": "HighlightOptions | boolean",
                    "references": {
                        "HighlightOptions": {
                            "location": "import",
                            "path": "@orama/highlight",
                            "id": "../../node_modules/.pnpm/@orama+highlight@0.1.9/node_modules/@orama/highlight/dist/index.d.ts::HighlightOptions"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "false"
            },
            "highlightDescription": {
                "type": "boolean",
                "attribute": "highlight-description",
                "mutable": false,
                "complexType": {
                    "original": "HighlightOptions | false",
                    "resolved": "HighlightOptions | boolean",
                    "references": {
                        "HighlightOptions": {
                            "location": "import",
                            "path": "@orama/highlight",
                            "id": "../../node_modules/.pnpm/@orama+highlight@0.1.9/node_modules/@orama/highlight/dist/index.d.ts::HighlightOptions"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "false"
            },
            "dictionary": {
                "type": "unknown",
                "attribute": "dictionary",
                "mutable": false,
                "complexType": {
                    "original": "Partial<Dictionary>",
                    "resolved": "{ searchPlaceholder?: string; chatPlaceholder?: string; noResultsFound?: string; noResultsFoundFor?: string; suggestions?: string; seeAll?: string; addMore?: string; clearChat?: string; errorMessage?: string; disclaimer?: string; startYourSearch?: string; initErrorSearch?: string; initErrorChat?: string; chatButtonLabel?: string; searchButtonLabel?: string; }",
                    "references": {
                        "Partial": {
                            "location": "global",
                            "id": "global::Partial"
                        },
                        "Dictionary": {
                            "location": "import",
                            "path": "@/types",
                            "id": "src/types/index.ts::Dictionary"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            }
        };
    }
    static get states() {
        return {
            "selectedFacet": {}
        };
    }
    static get events() {
        return [{
                "method": "searchCompleted",
                "name": "searchCompleted",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "complexType": {
                    "original": "OnSearchCompletedCallbackProps",
                    "resolved": "{ clientSearchParams: ClientSearchParams; result: { results: SearchResultBySection[]; resultsCount: number; facets: Facet[]; }; }",
                    "references": {
                        "OnSearchCompletedCallbackProps": {
                            "location": "import",
                            "path": "@/types",
                            "id": "src/types/index.ts::OnSearchCompletedCallbackProps"
                        }
                    }
                }
            }, {
                "method": "answerGenerated",
                "name": "answerGenerated",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "complexType": {
                    "original": "OnAnswerGeneratedCallbackProps",
                    "resolved": "{ askParams: AskParams; query: string; sources: Results<unknown>; answer: string; segment: string; trigger: string; }",
                    "references": {
                        "OnAnswerGeneratedCallbackProps": {
                            "location": "import",
                            "path": "@/types",
                            "id": "src/types/index.ts::OnAnswerGeneratedCallbackProps"
                        }
                    }
                }
            }];
    }
    static get elementRef() { return "el"; }
}
__decorate([
    Store('search')
], OramaSearch.prototype, "searchStore", void 0);
__decorate([
    Store('global')
], OramaSearch.prototype, "globalStore", void 0);
__decorate([
    Store('chat')
], OramaSearch.prototype, "chatStore", void 0);
//# sourceMappingURL=orama-search.js.map
