import { h, Fragment } from "@stencil/core";
import "@phosphor-icons/webcomponents/dist/icons/PhX.mjs";
export class SlideInPanel {
    constructor() {
        this.backdrop = false;
        this.open = false;
        this.isOpen = this.open;
    }
    openChanged() {
        this.isOpen = this.open;
    }
    closePanel() {
        if (this.closed) {
            this.closed();
        }
        this.isOpen = false;
    }
    trapFocus(event) {
        var _a;
        const focusableElements = (_a = this.el) === null || _a === void 0 ? void 0 : _a.querySelectorAll('a[href], button, textarea, input, select, [tabindex]:not([tabindex="-1"])');
        let focusableArray = Array.from(focusableElements);
        focusableArray = focusableArray.filter((element) => element.tabIndex !== -1);
        if (focusableArray.length > 0) {
            this.firstFocusableElement = focusableArray[0];
            this.lastFocusableElement = focusableArray[focusableArray.length - 1];
            const focusedElement = this.el.querySelector(':focus');
            if (event.shiftKey && focusedElement === this.firstFocusableElement) {
                event.preventDefault();
                this.lastFocusableElement.focus();
            }
            else if (!event.shiftKey && focusedElement === this.lastFocusableElement) {
                event.preventDefault();
                this.firstFocusableElement.focus();
            }
        }
    }
    handleKeyDown(event) {
        event.stopPropagation();
        if (event.key === 'Escape') {
            this.closePanel();
        }
        if (event.key === 'Tab') {
            this.trapFocus(event);
        }
    }
    componentDidLoad() {
        this.isOpen = this.open;
    }
    render() {
        return (h(Fragment, { key: 'f88b00bf1fc61de9416fcbfe6401ff14d7865fd2' }, h("div", { key: 'dba8338860b889ca1bed7bf25de95be366f0a2f4', class: { 'slide-container': true, 'slide-up': this.isOpen }, tabIndex: this.isOpen ? 0 : -1 }, h("div", { key: '1f7b7c593782897ca63527c93cf775985f3682d2', class: "slide-container-header" }, h("button", { key: '08826ac5dc073eba459dd2fd9adbbe34521c48a5', onClick: () => this.closePanel(), "aria-expanded": this.isOpen ? 'true' : 'false', "aria-label": "Close panel", "aria-controls": "panel", class: "close-button", type: "button" }, h("ph-x", { key: 'e1f618268881eeb161291e7b25accdc9835e453a', size: "18" }))), h("div", { key: 'd032def08d136efb85b7dcc203b855c211024537', id: "panel", "aria-hidden": !this.isOpen, tabindex: "-1", class: "slide-container-inner" }, h("slot", { key: '63db6812e71a0cc1a7fd0bc630a5200632908562' }))), this.backdrop && h("div", { key: 'a1da61d3366e055e2c3bb40cc60dd2ad14a8e9ac', class: { 'slide-backdrop': true, visible: this.isOpen } })));
    }
    static get is() { return "orama-sliding-panel"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["orama-sliding-panel.scss"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["orama-sliding-panel.css"]
        };
    }
    static get properties() {
        return {
            "backdrop": {
                "type": "boolean",
                "attribute": "backdrop",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "false"
            },
            "open": {
                "type": "boolean",
                "attribute": "open",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "false"
            },
            "closed": {
                "type": "unknown",
                "attribute": "closed",
                "mutable": false,
                "complexType": {
                    "original": "() => void",
                    "resolved": "() => void",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            }
        };
    }
    static get states() {
        return {
            "isOpen": {}
        };
    }
    static get elementRef() { return "el"; }
    static get watchers() {
        return [{
                "propName": "open",
                "methodName": "openChanged"
            }];
    }
    static get listeners() {
        return [{
                "name": "keydown",
                "method": "handleKeyDown",
                "target": "document",
                "capture": false,
                "passive": false
            }];
    }
}
//# sourceMappingURL=orama-sliding-panel.js.map
