import { h } from "@stencil/core";
export class OramaSuggestions {
    constructor() {
        this.as = 'chips';
    }
    handleClick(suggestion) {
        if (!this.suggestionClicked) {
            return;
        }
        this.suggestionClicked(suggestion);
    }
    render() {
        var _a;
        const isChips = this.as === 'chips';
        const isList = this.as === 'list';
        const classSuffix = isChips ? 'chips' : isList ? 'list' : '';
        if (!((_a = this.suggestions) === null || _a === void 0 ? void 0 : _a.length)) {
            return null;
        }
        return (h("ul", { class: `suggestions-${classSuffix}` }, this.suggestions.map((suggestion) => {
            return (h("li", { key: suggestion.split(' ').join('-').toLowerCase(), class: `suggestion-item-${classSuffix}` }, h("button", { "focus-on-arrow-nav": true, type: "button", class: `suggestion-button-${classSuffix}`, onClick: (e) => {
                    e.preventDefault();
                    this.handleClick(suggestion);
                } }, this.icon, suggestion)));
        })));
    }
    static get is() { return "orama-suggestions"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["orama-suggestions.scss"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["orama-suggestions.css"]
        };
    }
    static get properties() {
        return {
            "suggestions": {
                "type": "unknown",
                "attribute": "suggestions",
                "mutable": false,
                "complexType": {
                    "original": "string[]",
                    "resolved": "string[]",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            },
            "as": {
                "type": "string",
                "attribute": "as",
                "mutable": false,
                "complexType": {
                    "original": "'chips' | 'list'",
                    "resolved": "\"chips\" | \"list\"",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "'chips'"
            },
            "icon": {
                "type": "unknown",
                "attribute": "icon",
                "mutable": false,
                "complexType": {
                    "original": "Node",
                    "resolved": "Node",
                    "references": {
                        "Node": {
                            "location": "global",
                            "id": "global::Node"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            },
            "suggestionClicked": {
                "type": "unknown",
                "attribute": "suggestion-clicked",
                "mutable": false,
                "complexType": {
                    "original": "(suggestion: string) => void",
                    "resolved": "(suggestion: string) => void",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            }
        };
    }
}
//# sourceMappingURL=orama-suggestions.js.map
