export class WindowService extends EventTarget {
    constructor() {
        super();
        this._width = window.innerWidth;
        this.handleResize = this.handleResize.bind(this);
        window.addEventListener('resize', this.handleResize);
    }
    handleResize() {
        this._width = window.innerWidth;
        this.dispatchEvent(new CustomEvent('widthChange', { detail: this._width }));
    }
    get width() {
        return this._width;
    }
}
const windowWidthListener = new WindowService();
export { windowWidthListener };
//# sourceMappingURL=WindowService.js.map
