import { p as proxyCustomElement, H, c as createEvent, h, F as Fragment } from './p-BGpMMtbT.js';
import { O as OramaClientNotInitializedError, S as Switch, C as ChatService } from './p-Dr7-Mq-_.js';
import { g as generateRandomID, b as arrowKeysNavigation, u as updateThemeClasses, a as updateCssVariables, i as initOramaClient, v as validateCloudIndexConfig } from './p-BQsBOb3k.js';
import { d as defaultTextDictionary, g as getText } from './p-Db5sp_fc.js';
import { i as initStore, r as removeAllStores } from './p-9VPaspy8.js';
import { d as defineCustomElement$n } from './p-B65Mn12l.js';
import { d as defineCustomElement$m } from './p-DrE2-yuk.js';
import { d as defineCustomElement$l } from './p-C7v3W-8p.js';
import { d as defineCustomElement$k } from './p-CTt88pb0.js';
import { d as defineCustomElement$j } from './p-B6vpyv53.js';
import { d as defineCustomElement$i } from './p-CYieqRjH.js';
import { d as defineCustomElement$h } from './p-D_9XQiZ7.js';
import { d as defineCustomElement$g } from './p-CATLLnEA.js';
import { d as defineCustomElement$f } from './p-BgN2hEjy.js';
import { d as defineCustomElement$e } from './p-bmDZYFWR.js';
import { d as defineCustomElement$d } from './p-CegKHeec.js';
import { d as defineCustomElement$c } from './p-4sqp5s07.js';
import { d as defineCustomElement$b } from './p-D12Opl02.js';
import { d as defineCustomElement$a } from './p-Ck8Gih42.js';
import { d as defineCustomElement$9 } from './p-BndWlfiB.js';
import { d as defineCustomElement$8 } from './p-CH-7DZ3H.js';
import { d as defineCustomElement$7 } from './p-DDcIPJdp.js';
import { d as defineCustomElement$6 } from './p-nukcq9c8.js';
import { d as defineCustomElement$5 } from './p-9Kx-45gq.js';
import { d as defineCustomElement$4 } from './p-Ct9q51SM.js';
import { d as defineCustomElement$3 } from './p-COgGb6VX.js';
import { d as defineCustomElement$2 } from './p-ih_RspzP.js';

var __rest = (undefined && undefined.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
const LIMIT_RESULTS = 10;
class SearchService {
    constructor(oramaClient, oramaCoreClient, searchStore) {
        this.search = async (term, selectedFacet, callbacks) => {
            var _a, _b, _c, _d;
            if (!this.client) {
                throw new OramaClientNotInitializedError();
            }
            this.abortSearch();
            if (!term) {
                this.searchStore.state.results = [];
                this.searchStore.state.count = 0;
                this.searchStore.state.facets = [];
                this.searchStore.state.highlightedIndex = -1;
                return;
            }
            this.searchStore.state.loading = true;
            const latestAbortController = this.abortController;
            const _e = (_a = this.searchStore.state.searchParams) !== null && _a !== void 0 ? _a : {}, { limit, where } = _e, restSearchParams = __rest(_e, ["limit", "offset", "where"]);
            const clientSearchParams = Object.assign(Object.assign(Object.assign(Object.assign({}, restSearchParams), { term, limit: limit || LIMIT_RESULTS }), (where ? { where } : {})), (this.searchStore.state.facetProperty && Object.assign({ facets: {
                    [this.searchStore.state.facetProperty]: {},
                } }, (selectedFacet &&
                selectedFacet !== 'All' && {
                where: Object.assign({ [this.searchStore.state.facetProperty]: {
                        eq: selectedFacet,
                    } }, where),
            }))));
            try {
                const results = await this.client.search(clientSearchParams);
                if (latestAbortController.signal.aborted) {
                    return;
                }
                if (results && !results.hits) {
                    throw new Error('This search was made by a OramaClient with property mergeResult set to false. Orama Search Service requires mergeResult to be true.');
                }
                // biome-ignore lint/suspicious/noExplicitAny: To be fixed when Orama Swtich export the right type
                this.searchStore.state.results = this.parserResults(results === null || results === void 0 ? void 0 : results.hits, this.searchStore.state.resultMap);
                this.searchStore.state.count = (results === null || results === void 0 ? void 0 : results.count) || 0;
                this.searchStore.state.facets = this.parseFacets(results === null || results === void 0 ? void 0 : results.facets, this.searchStore.state.facetProperty);
                this.searchStore.state.highlightedIndex = -1;
                this.searchStore.state.loading = false;
                (_b = callbacks === null || callbacks === void 0 ? void 0 : callbacks.onSearchCompletedCallback) === null || _b === void 0 ? void 0 : _b.call(callbacks, {
                    clientSearchParams,
                    result: {
                        results: this.searchStore.state.results,
                        resultsCount: this.searchStore.state.count,
                        facets: this.searchStore.state.facets,
                    },
                });
                (_c = callbacks === null || callbacks === void 0 ? void 0 : callbacks.onSearchCompletedCallback) === null || _c === void 0 ? void 0 : _c.call(callbacks, {
                    clientSearchParams,
                    result: {
                        results: this.searchStore.state.results,
                        resultsCount: this.searchStore.state.count,
                        facets: this.searchStore.state.facets,
                    },
                });
            }
            catch (error) {
                console.error('Search error:', error);
                if (latestAbortController.signal.aborted) {
                    return;
                }
                this.searchStore.state.loading = false;
                (_d = callbacks === null || callbacks === void 0 ? void 0 : callbacks.onSearchErrorCallback) === null || _d === void 0 ? void 0 : _d.call(callbacks, error);
            }
        };
        // TODO
        this.retry = () => {
            throw new Error('Not implemented');
        };
        this.getResultMapObjectByForTheHit = (resultMapArrayOrObject, hit) => {
            const resultMapArray = Array.isArray(resultMapArrayOrObject) ? resultMapArrayOrObject : [resultMapArrayOrObject];
            // If there is only one result map, assume it's the one for all hits, regardless of datasourceId
            if (resultMapArray.length === 1) {
                return resultMapArray[0];
            }
            // TODO: Instead of doing it per each HIT, we may want to create a map of datasourceId -> resultMap to avoid the O(n) lookup
            const resultmapMatch = resultMapArray.find((resultMap) => resultMap.datasourceId === hit.datasource_id);
            return resultmapMatch || {};
        };
        this.parserResults = (hits, resultMapArrayOrObject) => {
            if (!hits) {
                return [];
            }
            const perSectionResults = [];
            const arraySectionMap = {};
            for (const hit of hits) {
                const resultMap = this.getResultMapObjectByForTheHit(resultMapArrayOrObject, hit);
                const searchResultWithScore = this.hitToSearchResultParser(hit, resultMap);
                const documentSectionValue = typeof resultMap.section === 'function'
                    ? resultMap.section(hit.document, hit.datasource_id)
                    : hit.document[resultMap.section];
                if (arraySectionMap[documentSectionValue] === undefined) {
                    perSectionResults.push({
                        section: documentSectionValue,
                        items: [searchResultWithScore],
                    });
                    arraySectionMap[documentSectionValue] = perSectionResults.length - 1;
                }
                else {
                    const sectionIndex = arraySectionMap[documentSectionValue];
                    perSectionResults[sectionIndex].items.push(searchResultWithScore);
                }
            }
            return perSectionResults;
        };
        this.hitToSearchResultParser = (hit, resultMapObject) => {
            function getResultMapValue(resultMapKey) {
                const resultMapFunctionOrString = resultMapObject[resultMapKey];
                if (!resultMapFunctionOrString) {
                    return hit.document[resultMapKey];
                }
                if (typeof resultMapFunctionOrString === 'function') {
                    const resultMapFunction = resultMapFunctionOrString;
                    return resultMapFunction(hit.document, hit.datasource_id);
                }
                const resultMapString = resultMapObject[resultMapKey];
                return hit.document[resultMapString];
            }
            function getIcon() {
                const iconStringOrFunction = resultMapObject.icon;
                if (!iconStringOrFunction) {
                    return null;
                }
                if (typeof iconStringOrFunction === 'function') {
                    const iconFunctionRender = iconStringOrFunction;
                    const iconFunctionRenderResult = iconFunctionRender(hit.document, hit.datasource_id);
                    return iconFunctionRenderResult !== null && iconFunctionRenderResult !== void 0 ? iconFunctionRenderResult : null;
                }
                return resultMapObject.icon;
            }
            return {
                id: hit.id,
                title: getResultMapValue('title'),
                description: getResultMapValue('description'),
                path: getResultMapValue('path'),
                icon: getIcon(),
            };
        };
        this.parseFacets = (rawFacets, facetProperty) => {
            // Handle case where facets are missing or empty
            if (!facetProperty || !rawFacets) {
                return [];
            }
            // Handle different facet formats based on client type
            const facetPropertyObject = rawFacets[facetProperty];
            if (!facetPropertyObject || !facetPropertyObject.values) {
                return [];
            }
            // Process facets in standard format
            const totalCount = Object.values(facetPropertyObject.values).reduce((acc, count) => acc + count, 0);
            const allFacets = Object.keys(facetPropertyObject.values).map((key) => {
                return {
                    name: key,
                    count: facetPropertyObject.values[key],
                };
            });
            allFacets.unshift({ name: 'All', count: totalCount });
            return allFacets;
        };
        this.client = oramaCoreClient ? oramaCoreClient : new Switch(oramaClient);
        this.searchStore = searchStore;
        this.abortController = new AbortController();
    }
    abortSearch() {
        this.abortController.abort();
        this.abortController = new AbortController();
    }
}

class WindowService extends EventTarget {
    constructor() {
        super();
        this._width = window.innerWidth;
        this.handleResize = this.handleResize.bind(this);
        window.addEventListener('resize', this.handleResize);
    }
    handleResize() {
        this._width = window.innerWidth;
        this.dispatchEvent(new CustomEvent('widthChange', { detail: this._width }));
    }
    get width() {
        return this._width;
    }
}
const windowWidthListener = new WindowService();

const oramaSearchBoxCss = "@keyframes showIn{0%{opacity:0;transform:translateY(-25%)}to{opacity:1;transform:translateY(0)}}@media (min-width:1024.02px){.modal orama-input{border-radius:0;margin:0;padding:0}.modal input[type=search]{border-radius:.75rem .75rem 0 0;border-radius:var(--radius-m,calc(12rem/var(--orama-base-font-size, 16))) var(--radius-m,calc(12rem/var(--orama-base-font-size, 16))) 0 0}}.main{flex-direction:column;flex-grow:1}.main,.section-active{display:flex;overflow:hidden}.section-inactive{display:none}";

const SearchBox = /*@__PURE__*/ proxyCustomElement(class SearchBox extends H {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.searchCompleted = createEvent(this, "searchCompleted");
        this.searchResultClick = createEvent(this, "searchResultClick");
        this.clearChat = createEvent(this, "clearChat");
        this.startConversation = createEvent(this, "startConversation");
        this.answerGenerated = createEvent(this, "answerGenerated");
        this.answerSourceClick = createEvent(this, "answerSourceClick");
        this.chatMarkdownLinkClicked = createEvent(this, "chatMarkdownLinkClicked");
        this.modalClosed = createEvent(this, "modalClosed");
        this.modalStatusChanged = createEvent(this, "modalStatusChanged");
        /**
         * Component color schema
         */
        this.colorScheme = 'light';
        this.open = false;
        /**
         * Used to map dataset result properties to the expected SearchBox properties
         */
        this.resultMap = {};
        /**
         * Disables chat capabilities
         */
        this.disableChat = false;
        /**
         * This component can behave either as Modal or a Embed component.
         * For Modal, a new absolute panel will be displayed on top.
         * For Embed, Orama Search Box will be displayed as a inline component.
         */
        this.layout = 'modal';
        /**
         * Options for highlights of Search Result titles
         */
        this.highlightTitle = false;
        /**
         * Options for highlights of Search Result descriptions
         */
        this.highlightDescription = false;
        /**
         * Clear chat on disconnect
         */
        this.clearChatOnDisconnect = true;
        /**
         * Show keyboard shortcuts in the footer
         */
        this.showKeyboardShortcuts = true;
        /**
         * Custom text dictionary for localization
         * @example
         * const searchBox = document.querySelector('orama-search-box');
         * searchBox.dictionary = { searchPlaceholder: "Search our products..." };
         */
        this.dictionary = {};
        this.componentID = generateRandomID('search-box');
        this.systemScheme = 'light';
        this.closeSearchbox = () => {
            this.globalStore.state.open = false;
            this.open = false;
        };
        this.onChatButtonClick = () => {
            this.globalStore.state.currentTask = 'chat';
        };
        this.onPrefersColorSchemeChange = (event) => {
            this.systemScheme = event.matches ? 'dark' : 'light';
            this.updateTheme();
        };
        this.updateWindowWidth = (event) => {
            this.windowWidth = event.detail;
        };
    }
    /**
     * Watch for changes to the dictionary prop
     */
    handleDictionaryChange(newValue) {
        let parsedNewValue = {};
        if (typeof newValue === 'string') {
            try {
                parsedNewValue = JSON.parse(newValue);
            }
            catch (e) {
                console.error('Failed to parse dictionary string:', e);
                // Keep current internalTextDictionary or revert to pure defaults if preferred
            }
        }
        else {
            parsedNewValue = newValue || {};
        }
        this.internalTextDictionary = Object.assign(Object.assign({}, defaultTextDictionary), parsedNewValue);
    }
    indexChanged() {
        // This is a naive way to check if it is safe to eval this method (after componentWillLoad)
        if (!this.searchStore) {
            return;
        }
        this.bootstrap();
    }
    watchHandler() {
        this.updateTheme();
    }
    handleOpenPropChange(newValue) {
        this.globalStore.state.open = newValue;
        this.modalStatusChanged.emit({
            open: newValue,
            id: this.wrapperRef,
        });
        if (!newValue) {
            this.modalClosed.emit();
        }
    }
    handleFacetPropertyChange(newValue) {
        this.searchStore.state.facetProperty = newValue;
    }
    handleSearchParamsChange(newValue) {
        this.searchStore.state.searchParams = newValue;
    }
    handleKeyDown(ev) {
        var _a;
        if (((_a = this.globalStore) === null || _a === void 0 ? void 0 : _a.state.currentTask) === 'search' &&
            ((this.layout === 'modal' && this.open) || this.layout === 'embed') &&
            ['ArrowDown', 'ArrowUp'].includes(ev.key)) {
            arrowKeysNavigation(this.wrapperRef, ev);
        }
    }
    updateTheme() {
        const scheme = updateThemeClasses(this.htmlElement, this.colorScheme, this.systemScheme);
        updateCssVariables(this.htmlElement, scheme, this.themeConfig);
    }
    getOldOramaClient() {
        if (this.oramaCoreClientInstance) {
            return undefined;
        }
        if (this.clientInstance) {
            return this.clientInstance;
        }
        return initOramaClient(this.index);
    }
    bootstrap() {
        this.searchStore.state.facetProperty = this.facetProperty;
        this.searchStore.state.resultMap = this.resultMap;
        this.searchStore.state.searchParams = this.searchParams;
        this.startServices();
    }
    startServices() {
        if (!this.index && !this.clientInstance && !this.oramaCoreClientInstance) {
            // Skip initialization if no index or clientInstance is provided
            return;
        }
        validateCloudIndexConfig(this.htmlElement, this.index, this.clientInstance, this.oramaCoreClientInstance);
        const oldOramaClient = this.getOldOramaClient();
        this.searchStore.state.searchService = new SearchService(oldOramaClient, this.oramaCoreClientInstance, this.searchStore);
        this.chatStore.state.chatService = new ChatService(oldOramaClient, this.oramaCoreClientInstance, this.chatStore);
    }
    componentWillLoad() {
        this.htmlElement.id = this.componentID;
        this.bootstrap();
        this.globalStore.state.open = this.open;
        this.globalStore.onChange('open', () => {
            if (!this.globalStore) {
                return;
            }
            this.open = this.globalStore.state.open;
            if (!this.globalStore.state.open) {
                this.globalStore.state.currentTerm = '';
                // TODO: We should be reseting the context, but we do not want to lose params definitions.
                // We may want to handle params in a different way.
                this.searchStore.state.facets = [];
                this.searchStore.state.count = 0;
                this.searchStore.state.results = [];
                this.searchStore.state.highlightedIndex = -1;
                this.searchStore.state.loading = false;
                this.searchStore.state.error = false;
                this.chatStore.state.interactions = [];
                setTimeout(() => { });
            }
        });
        this.schemaQuery = window.matchMedia('(prefers-color-scheme: dark)');
        this.systemScheme = this.schemaQuery.matches ? 'dark' : 'light';
        this.updateTheme();
        this.schemaQuery.addEventListener('change', this.onPrefersColorSchemeChange);
        windowWidthListener.addEventListener('widthChange', this.updateWindowWidth);
        let propValue = {};
        if (typeof this.dictionary === 'string') {
            try {
                propValue = JSON.parse(this.dictionary);
            }
            catch (e) {
                console.error('Failed to parse initial dictionary string:', e);
            }
        }
        else {
            propValue = this.dictionary || {};
        }
        this.internalTextDictionary = Object.assign(Object.assign({}, defaultTextDictionary), propValue);
    }
    connectedCallback() {
        this.chatStore = initStore('chat', this.componentID);
        this.searchStore = initStore('search', this.componentID);
        this.globalStore = initStore('global', this.componentID);
        this.windowWidth = windowWidthListener.width;
    }
    disconnectedCallback() {
        var _a;
        removeAllStores(this.componentID);
        windowWidthListener.removeEventListener('widthChange', this.updateWindowWidth);
        (_a = this.schemaQuery) === null || _a === void 0 ? void 0 : _a.removeEventListener('change', this.onPrefersColorSchemeChange);
    }
    /**
     * Gets the text for a specific key from the dictionary prop.
     * Prioritizes direct props (searchPlaceholder, chatPlaceholder) for backward compatibility,
     * then falls back to the dictionary prop, and finally to the defaultTextDictionary.
     *
     * @param key - The key to get the text for
     * @returns The text for the specified key
     */
    getText(key) {
        // Create a map of direct props for backward compatibility
        const directProps = {
            searchPlaceholder: this.searchPlaceholder,
            chatPlaceholder: this.chatPlaceholder,
        };
        return getText(key, this.internalTextDictionary, directProps);
    }
    getSearchBox() {
        return (h("div", { class: `${this.windowWidth > 1024
                ? 'section-active'
                : this.globalStore.state.currentTask === 'search'
                    ? 'section-active'
                    : 'section-inactive'}` }, h("orama-search", { placeholder: this.getText('searchPlaceholder'), focusInput: this.globalStore.state.currentTask === 'search', sourceBaseUrl: this.sourceBaseUrl, linksTarget: this.linksTarget, linksRel: this.linksRel, highlightTitle: this.highlightTitle, highlightDescription: this.highlightDescription, disableChat: this.disableChat, suggestions: this.suggestions, dictionary: this.internalTextDictionary }, this.windowWidth > 1024 && !this.disableChat && (h("orama-chat-button", { slot: "summary", "focus-on-arrow-nav": true, active: !!this.globalStore.state.currentTerm, label: `${this.globalStore.state.currentTerm ? `${this.globalStore.state.currentTerm} - ` : ''}${this.getText('chatButtonLabel')}`, onClick: this.onChatButtonClick, onKeyPress: this.onChatButtonClick })))));
    }
    getChatBox() {
        return (h(Fragment, null, h("orama-chat", { class: `${this.globalStore.state.currentTask === 'chat' ? 'section-active' : 'section-inactive'}`, defaultTerm: this.globalStore.state.currentTask === 'chat' ? this.globalStore.state.currentTerm : '', showClearChat: false, focusInput: this.globalStore.state.currentTask === 'chat', placeholder: this.getText('chatPlaceholder'), sourceBaseUrl: this.sourceBaseUrl, linksTarget: this.linksTarget, linksRel: this.linksRel, sourcesMap: this.sourcesMap, suggestions: this.suggestions, chatMarkdownLinkTitle: this.chatMarkdownLinkTitle, chatMarkdownLinkHref: this.chatMarkdownLinkHref, chatMarkdownLinkTarget: this.chatMarkdownLinkTarget, disclaimer: this.disclaimer, dictionary: this.internalTextDictionary, systemPrompts: this.systemPrompts, prompt: this.prompt, clearChatOnDisconnect: this.clearChatOnDisconnect, relatedQueries: this.relatedQueries })));
    }
    getInnerContent() {
        return (h(Fragment, null, this.disableChat ? null : (h("orama-navigation-bar", { handleClose: this.closeSearchbox, showBackButton: this.layout !== 'embed', showChatActions: this.globalStore.state.currentTask === 'chat' })), h("div", { class: "main" }, this.getSearchBox(), this.windowWidth <= 1024 && this.getChatBox()), h("orama-footer", { colorScheme: this.colorScheme === 'system' ? this.systemScheme : this.colorScheme, showKeyboardShortcuts: this.showKeyboardShortcuts })));
    }
    getOuterContent() {
        return this.windowWidth > 1024 ? (h("orama-sliding-panel", { open: this.globalStore.state.currentTask === 'chat', backdrop: this.layout === 'embed', closed: () => {
                this.globalStore.state.currentTask = 'search';
            } }, this.getChatBox())) : null;
    }
    getModalLayout() {
        return (h(Fragment, null, h("orama-modal", { ref: (el) => (this.wrapperRef = el), class: "modal", mainTitle: this.getText('startYourSearch'), onModalClosed: (e) => {
                this.open = false;
                e.stopPropagation();
            }, closeOnEscape: this.globalStore.state.currentTask === 'search' || this.windowWidth <= 1024 }, this.getInnerContent()), this.getOuterContent()));
    }
    getEmbedLayout() {
        return (h(Fragment, null, h("orama-embed", { ref: (el) => (this.wrapperRef = el) }, this.getInnerContent()), this.getOuterContent()));
    }
    render() {
        if (this.layout === 'modal' && !this.globalStore.state.open) {
            return null;
        }
        if (!this.searchStore.state.searchService) {
            return null;
        }
        if (!this.chatStore.state.chatService) {
            return null;
        }
        return this.layout === 'modal' ? this.getModalLayout() : this.getEmbedLayout();
    }
    get htmlElement() { return this; }
    static get watchers() { return {
        "dictionary": ["handleDictionaryChange"],
        "index": ["indexChanged"],
        "clientInstance": ["indexChanged"],
        "oramaCoreClientInstance": ["indexChanged"],
        "themeConfig": ["watchHandler"],
        "colorScheme": ["watchHandler"],
        "open": ["handleOpenPropChange"],
        "facetProperty": ["handleFacetPropertyChange"],
        "searchParams": ["handleSearchParamsChange"]
    }; }
    static get style() { return oramaSearchBoxCss; }
}, [1, "orama-search-box", {
        "themeConfig": [16, "theme-config"],
        "colorScheme": [1, "color-scheme"],
        "index": [16],
        "clientInstance": [16, "client-instance"],
        "oramaCoreClientInstance": [16, "orama-core-client-instance"],
        "open": [1540],
        "facetProperty": [1, "facet-property"],
        "resultMap": [16, "result-map"],
        "resultItemRender": [16, "result-item-render"],
        "sourceBaseUrl": [1, "source-base-url"],
        "linksTarget": [1, "links-target"],
        "linksRel": [1, "links-rel"],
        "sourcesMap": [16, "sources-map"],
        "disableChat": [4, "disable-chat"],
        "layout": [1],
        "highlightTitle": [4, "highlight-title"],
        "highlightDescription": [4, "highlight-description"],
        "prompt": [1],
        "chatPlaceholder": [1, "chat-placeholder"],
        "searchPlaceholder": [1, "search-placeholder"],
        "suggestions": [16],
        "searchParams": [16, "search-params"],
        "chatMarkdownLinkTitle": [16, "chat-markdown-link-title"],
        "chatMarkdownLinkHref": [16, "chat-markdown-link-href"],
        "clearChatOnDisconnect": [4, "clear-chat-on-disconnect"],
        "systemPrompts": [16, "system-prompts"],
        "chatMarkdownLinkTarget": [16, "chat-markdown-link-target"],
        "showKeyboardShortcuts": [4, "show-keyboard-shortcuts"],
        "disclaimer": [1],
        "dictionary": [16],
        "relatedQueries": [2, "related-queries"],
        "internalTextDictionary": [32],
        "componentID": [32],
        "systemScheme": [32],
        "windowWidth": [32]
    }, [[4, "keydown", "handleKeyDown"]], {
        "dictionary": ["handleDictionaryChange"],
        "index": ["indexChanged"],
        "clientInstance": ["indexChanged"],
        "oramaCoreClientInstance": ["indexChanged"],
        "themeConfig": ["watchHandler"],
        "colorScheme": ["watchHandler"],
        "open": ["handleOpenPropChange"],
        "facetProperty": ["handleFacetPropertyChange"],
        "searchParams": ["handleSearchParamsChange"]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["orama-search-box", "orama-button", "orama-chat", "orama-chat-assistent-message", "orama-chat-button", "orama-chat-messages-container", "orama-chat-user-message", "orama-dots-loader", "orama-embed", "orama-facets", "orama-footer", "orama-input", "orama-markdown", "orama-modal", "orama-navigation-bar", "orama-search", "orama-search-results", "orama-sliding-panel", "orama-sources", "orama-suggestions", "orama-text", "orama-textarea", "orama-toggler"];
    components.forEach(tagName => { switch (tagName) {
        case "orama-search-box":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, SearchBox);
            }
            break;
        case "orama-button":
            if (!customElements.get(tagName)) {
                defineCustomElement$n();
            }
            break;
        case "orama-chat":
            if (!customElements.get(tagName)) {
                defineCustomElement$m();
            }
            break;
        case "orama-chat-assistent-message":
            if (!customElements.get(tagName)) {
                defineCustomElement$l();
            }
            break;
        case "orama-chat-button":
            if (!customElements.get(tagName)) {
                defineCustomElement$k();
            }
            break;
        case "orama-chat-messages-container":
            if (!customElements.get(tagName)) {
                defineCustomElement$j();
            }
            break;
        case "orama-chat-user-message":
            if (!customElements.get(tagName)) {
                defineCustomElement$i();
            }
            break;
        case "orama-dots-loader":
            if (!customElements.get(tagName)) {
                defineCustomElement$h();
            }
            break;
        case "orama-embed":
            if (!customElements.get(tagName)) {
                defineCustomElement$g();
            }
            break;
        case "orama-facets":
            if (!customElements.get(tagName)) {
                defineCustomElement$f();
            }
            break;
        case "orama-footer":
            if (!customElements.get(tagName)) {
                defineCustomElement$e();
            }
            break;
        case "orama-input":
            if (!customElements.get(tagName)) {
                defineCustomElement$d();
            }
            break;
        case "orama-markdown":
            if (!customElements.get(tagName)) {
                defineCustomElement$c();
            }
            break;
        case "orama-modal":
            if (!customElements.get(tagName)) {
                defineCustomElement$b();
            }
            break;
        case "orama-navigation-bar":
            if (!customElements.get(tagName)) {
                defineCustomElement$a();
            }
            break;
        case "orama-search":
            if (!customElements.get(tagName)) {
                defineCustomElement$9();
            }
            break;
        case "orama-search-results":
            if (!customElements.get(tagName)) {
                defineCustomElement$8();
            }
            break;
        case "orama-sliding-panel":
            if (!customElements.get(tagName)) {
                defineCustomElement$7();
            }
            break;
        case "orama-sources":
            if (!customElements.get(tagName)) {
                defineCustomElement$6();
            }
            break;
        case "orama-suggestions":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "orama-text":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "orama-textarea":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "orama-toggler":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
    } });
}

const OramaSearchBox = SearchBox;
const defineCustomElement = defineCustomElement$1;

export { OramaSearchBox, defineCustomElement };
//# sourceMappingURL=orama-search-box.js.map

//# sourceMappingURL=orama-search-box.js.map