import { p as proxyCustomElement, H, h } from './p-BGpMMtbT.js';

const oramaSuggestionsCss = ".suggestions-chips.sc-orama-suggestions{align-items:center;display:flex;gap:.75rem;gap:var(--spacing-m,calc(12rem/var(--orama-base-font-size, 16)));list-style:none;margin:0;overflow-x:auto;padding:.5rem 1rem;padding:var(--radius-s,calc(8rem/var(--orama-base-font-size, 16))) var(--radius-l,calc(16rem/var(--orama-base-font-size, 16)))}.suggestions-chips.sc-orama-suggestions::-webkit-scrollbar{background-color:transparent;height:0}@media (min-width:768.02px){.suggestions-chips.sc-orama-suggestions{flex-wrap:wrap;justify-content:center}}.suggestion-button-chips.sc-orama-suggestions{align-items:center;background-color:#fff;background-color:var(--background-color-secondary,#fff);border:1px solid #dadada;border:1px solid var(--border-color-primary,#dadada);border-radius:1rem;border-radius:var(--radius-l,calc(16rem/var(--orama-base-font-size, 16)));color:#151515;color:var(--text-color-primary,#151515);color:#838289;color:var(--text-color-secondary,#838289);-moz-column-gap:.5rem;column-gap:.5rem;-moz-column-gap:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));column-gap:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));cursor:pointer;display:flex;font-size:.875rem;font-size:var(--font-size-sm,calc(14rem/var(--orama-base-font-size, 16)));font-weight:400;font-weight:var(--font-weight-normal,400);line-height:1.25;line-height:var(--font-line-height-s,1.25);margin:0;padding:.5rem;padding:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));transition:background-color .2s;width:-moz-max-content;width:max-content}@media (hover:hover){.suggestion-button-chips.sc-orama-suggestions:hover{background-color:#eee9f6;background-color:var(--background-color-tertiary,#eee9f6)}}.suggestion-button-chips.sc-orama-suggestions:focus-visible{border:1px solid #432d77;border:1px solid var(--border-color-accent,#432d77);outline:none}.suggestions-list.sc-orama-suggestions{align-items:center;display:flex;flex-wrap:wrap;list-style:none;margin:0;padding:0}.suggestion-item-list.sc-orama-suggestions{width:100%}.suggestion-button-list.sc-orama-suggestions{align-items:center;background-color:transparent;background:linear-gradient(90deg,#ae8ff7,#151515);background:linear-gradient(90deg,var(--text-color-accent,#ae8ff7) 0,var(--text-color-primary,#151515) 100%);-webkit-background-clip:text;background-clip:text;color:#838289;color:var(--text-color-secondary,#838289);-moz-column-gap:.5rem;column-gap:.5rem;-moz-column-gap:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));column-gap:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));cursor:pointer;display:flex;font-size:.875rem;font-size:var(--font-size-sm,calc(14rem/var(--orama-base-font-size, 16)));padding:.5rem .75rem;padding:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16))) var(--spacing-m,calc(12rem/var(--orama-base-font-size, 16)));text-align:left;-webkit-text-fill-color:transparent;border:1px solid transparent;font-family:inherit;width:100%}.suggestion-button-list.sc-orama-suggestions:focus-visible{border:1px solid #432d77;border:1px solid var(--border-color-accent,#432d77);border-radius:.5rem;border-radius:var(--radius-s,calc(8rem/var(--orama-base-font-size, 16)));outline:none}";

const OramaSuggestions = /*@__PURE__*/ proxyCustomElement(class OramaSuggestions extends H {
    constructor() {
        super();
        this.__registerHost();
        this.as = 'chips';
    }
    handleClick(suggestion) {
        if (!this.suggestionClicked) {
            return;
        }
        this.suggestionClicked(suggestion);
    }
    render() {
        var _a;
        const isChips = this.as === 'chips';
        const isList = this.as === 'list';
        const classSuffix = isChips ? 'chips' : isList ? 'list' : '';
        if (!((_a = this.suggestions) === null || _a === void 0 ? void 0 : _a.length)) {
            return null;
        }
        return (h("ul", { class: `suggestions-${classSuffix}` }, this.suggestions.map((suggestion) => {
            return (h("li", { key: suggestion.split(' ').join('-').toLowerCase(), class: `suggestion-item-${classSuffix}` }, h("button", { "focus-on-arrow-nav": true, type: "button", class: `suggestion-button-${classSuffix}`, onClick: (e) => {
                    e.preventDefault();
                    this.handleClick(suggestion);
                } }, this.icon, suggestion)));
        })));
    }
    static get style() { return oramaSuggestionsCss; }
}, [2, "orama-suggestions", {
        "suggestions": [16],
        "as": [1],
        "icon": [16],
        "suggestionClicked": [16, "suggestion-clicked"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["orama-suggestions"];
    components.forEach(tagName => { switch (tagName) {
        case "orama-suggestions":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, OramaSuggestions);
            }
            break;
    } });
}

export { OramaSuggestions as O, defineCustomElement as d };
//# sourceMappingURL=p-9Kx-45gq.js.map

//# sourceMappingURL=p-9Kx-45gq.js.map