import { p as proxyCustomElement, H, h } from './p-BGpMMtbT.js';
import { c as getNonExplicitAttributes } from './p-BQsBOb3k.js';

const oramaButtonCss = ".button.sc-orama-button{align-items:center;border:0;border-radius:.75rem;border-radius:var(--radius-m,calc(12rem/var(--orama-base-font-size, 16)));cursor:pointer;display:flex;font-family:font(\"primary\");font-family:var(--font-primary,font(\"primary\"));gap:.5rem;gap:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));position:relative;text-align:left;transition:all .2s;transition-property:color,background-color,opacity;width:100%}.button__tooltip.sc-orama-button{animation:fadeInOut 1s ease-in-out 1;background-color:#151515;background-color:var(--text-color-primary,#151515);border-radius:.5rem;border-radius:var(--radius-s,calc(8rem/var(--orama-base-font-size, 16)));color:#fbfbfb;color:var(--background-color-primary,#fbfbfb);display:block;font-size:10px;opacity:0;padding:.5rem;padding:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));position:absolute;top:-28px;z-index:1}.button--small.sc-orama-button{padding:.25rem;padding:var(--spacing-xs,calc(4rem/var(--orama-base-font-size, 16)))}.button--medium.sc-orama-button{padding:.5rem;padding:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)))}.button--large.sc-orama-button{padding:.75rem;padding:var(--spacing-m,calc(12rem/var(--orama-base-font-size, 16)))}.button__label.sc-orama-button{align-items:center;display:flex;flex-grow:1;gap:.25rem;gap:var(--spacing-xs,calc(4rem/var(--orama-base-font-size, 16)))}.button--primary.sc-orama-button{background-color:#432d77;background-color:var(--button-background-color-primary,#432d77);color:#fbfbfb;color:var(--button-text-color-primary,#fbfbfb)}.button--primary.sc-orama-button:disabled{background-color:#eee9f6;background-color:var(--background-color-tertiary,#eee9f6);color:var(--text-color-tertiary)}.button--secondary.sc-orama-button{background-color:#fff;background-color:var(--button-background-color-secondary,#fff);border:1px solid #dadada;border:1px solid var(--button-border-color-secondary,#dadada);color:#838289;color:var(--button-text-color-secondary,#838289);transition:all .3s}@media (hover:hover){.button--secondary.sc-orama-button:hover{background-color:#eee9f6;background-color:var(--button-background-color-secondary-hover,#eee9f6)}}.button--secondary.sc-orama-button:focus-visible{border:1px solid #9671b0;outline:none}.button--secondary.sc-orama-button:disabled{background-color:#eee9f6;background-color:var(--background-color-tertiary,#eee9f6);color:var(--text-color-tertiary)}.button--icon.sc-orama-button{align-items:center;background-color:transparent;border-radius:50%;color:#99989d;color:var(--icon-color-tertiary,#99989d);font-family:font(\"primary\");font-family:var(--font-primary,font(\"primary\"));height:-moz-fit-content;height:fit-content;justify-content:center;padding:.5rem;padding:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));width:-moz-fit-content;width:fit-content}.button--icon.sc-orama-button:disabled{opacity:.6}.button--icon.sc-orama-button:disabled,.button--icon.sc-orama-button:hover{background-color:#eee9f6;background-color:var(--background-color-tertiary,#eee9f6)}.sc-orama-button-s>*{align-items:center;display:inline-flex}.sc-orama-button-s>[slot=adorment-end],.sc-orama-button-s>[slot=adorment-start]{flex-grow:0}@keyframes fadeInOut{0%{opacity:0}50%{opacity:1}to{opacity:0}}";

const OramaButton = /*@__PURE__*/ proxyCustomElement(class OramaButton extends H {
    constructor() {
        super();
        this.__registerHost();
        this.as = 'button';
        this.variant = 'primary';
        this.size = 'medium';
    }
    render() {
        const Tag = this.as;
        const declaredProps = ['as', 'class', 'variant'];
        const buttonProps = getNonExplicitAttributes(this.el, declaredProps);
        const buttonClass = `button button--${this.variant} button--${this.size} ${this.class || ''}`;
        return (h(Tag, Object.assign({ key: 'af470570a767787e5e85ec5c0ecc4cfb66e5b142', class: buttonClass }, buttonProps, { disabled: this.disabled }), h("span", { key: '483fb6a261decf60053ec78726912e11ae271e74', class: "button__label" }, h("slot", { key: '3d00cc8a7fe04471095f87b9989eebf38c79764a', name: "adorment-start" }), this.withTooltip && h("span", { key: 'bdda78c3dc2e39b53254a5506dcfb53bffdb9ed3', class: "button__tooltip" }, this.withTooltip), h("slot", { key: '6582b9e1c0481f18ac91844b0f09ff09b9fa1fbf' })), h("slot", { key: '31d3bcf229c837809ccf3ba74986a179fe028c87', name: "adorment-end" })));
    }
    get el() { return this; }
    static get style() { return oramaButtonCss; }
}, [6, "orama-button", {
        "as": [1],
        "class": [1],
        "variant": [1],
        "size": [1],
        "type": [1],
        "disabled": [4],
        "withTooltip": [1, "with-tooltip"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["orama-button"];
    components.forEach(tagName => { switch (tagName) {
        case "orama-button":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, OramaButton);
            }
            break;
    } });
}

export { OramaButton as O, defineCustomElement as d };
//# sourceMappingURL=p-B65Mn12l.js.map

//# sourceMappingURL=p-B65Mn12l.js.map