import { p as proxyCustomElement, H, c as createEvent, h, d as Host } from './p-BGpMMtbT.js';
import { S as Store } from './p-9VPaspy8.js';
import { d as defineCustomElement$8 } from './p-B65Mn12l.js';
import { d as defineCustomElement$7 } from './p-C7v3W-8p.js';
import { d as defineCustomElement$6 } from './p-CYieqRjH.js';
import { d as defineCustomElement$5 } from './p-D_9XQiZ7.js';
import { d as defineCustomElement$4 } from './p-4sqp5s07.js';
import { d as defineCustomElement$3 } from './p-nukcq9c8.js';
import { d as defineCustomElement$2 } from './p-9Kx-45gq.js';
import { d as defineCustomElement$1 } from './p-Ct9q51SM.js';

const oramaChatMessagesContainerCss = "orama-chat-messages-container.sc-orama-chat-messages-container::-webkit-scrollbar{width:.3em}orama-chat-messages-container.sc-orama-chat-messages-container::-webkit-scrollbar-track{background:transparent}orama-chat-messages-container.sc-orama-chat-messages-container::-webkit-scrollbar-thumb{background-color:hsla(0,0%,70%,.522);border-radius:1rem;border-radius:var(--border-radius-l,calc(16rem/var(--orama-base-font-size, 16)))}.messages-container.sc-orama-chat-messages-container{display:flex;flex-direction:column;gap:1.5rem;gap:var(--spacing-xl,calc(24rem/var(--orama-base-font-size, 16)));margin:1rem 0;margin:var(--spacing-l,calc(16rem/var(--orama-base-font-size, 16))) 0;overflow:hidden}.suggestions-wrapper.sc-orama-chat-messages-container{margin-top:1.5rem;margin-top:var(--spacing-xl,calc(24rem/var(--orama-base-font-size, 16)))}";

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const OramaChatMessagesContainer = /*@__PURE__*/ proxyCustomElement(class OramaChatMessagesContainer extends H {
    constructor() {
        super();
        this.__registerHost();
        this.answerGenerated = createEvent(this, "answerGenerated");
        this.latestInteractionMinHeight = 0;
        // TODO: I'm not sure about having this here as we're breaking our rule of maintain service access only to the very top level component
        this.onSuggestionClick = (suggestion) => {
            var _a;
            (_a = this.chatStore.state.chatService) === null || _a === void 0 ? void 0 : _a.sendQuestion(suggestion, undefined, undefined, {
                onAnswerGeneratedCallback: (onAnswerGeneratedCallbackProps) => this.answerGenerated.emit(onAnswerGeneratedCallbackProps),
            });
        };
        this.resizeObserver = new ResizeObserver((entries) => {
            // FIXME: We are removing the margin with a constant value. It should be calculated
            this.latestInteractionMinHeight = entries[0].target.clientHeight - 32;
        });
    }
    componentDidLoad() {
        // FIXME: We should get the element in another way. I tried findById or class and it was not working.
        // probable something related to the shadow dom
        const messagesWrapperElement = this.el.parentElement.parentElement;
        this.resizeObserver.observe(messagesWrapperElement);
    }
    render() {
        return (h(Host, { key: '16faa4d865e3c1c475a099c2a537c9fcd356bf7b' }, h("div", { key: '4fc29b18a434697d629e1327cffdce84d56a21c2', class: "messages-container" }, this.interactions.map((interaction, interactionIndex) => {
            var _a;
            return (h("div", { key: interaction.interactionId, class: "interaction-wrapper",
                // Hack to put the message on top when auto scrolling
                style: {
                    minHeight: this.interactions.length > 1 && interactionIndex === this.interactions.length - 1
                        ? `${this.latestInteractionMinHeight}px`
                        : '0px',
                } }, h("orama-chat-user-message", { interaction: Object.assign({}, interaction) }), h("orama-chat-assistent-message", { interaction: Object.assign({}, interaction), chatMarkdownLinkTitle: this.chatMarkdownLinkTitle, chatMarkdownLinkHref: this.chatMarkdownLinkHref }), interaction.latest && interaction.status === 'done' && !!((_a = interaction.relatedQueries) === null || _a === void 0 ? void 0 : _a.length) && (h("div", { class: "suggestions-wrapper" }, h("orama-suggestions", { as: "chips", suggestions: interaction.relatedQueries, suggestionClicked: this.onSuggestionClick })))));
        }))));
    }
    get el() { return this; }
    static get style() { return oramaChatMessagesContainerCss; }
}, [2, "orama-chat-messages-container", {
        "interactions": [16],
        "chatMarkdownLinkTitle": [16, "chat-markdown-link-title"],
        "chatMarkdownLinkHref": [16, "chat-markdown-link-href"],
        "chatMarkdownLinkTarget": [16, "chat-markdown-link-target"],
        "latestInteractionMinHeight": [32]
    }]);
__decorate([
    Store('chat')
], OramaChatMessagesContainer.prototype, "chatStore", void 0);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["orama-chat-messages-container", "orama-button", "orama-chat-assistent-message", "orama-chat-user-message", "orama-dots-loader", "orama-markdown", "orama-sources", "orama-suggestions", "orama-text"];
    components.forEach(tagName => { switch (tagName) {
        case "orama-chat-messages-container":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, OramaChatMessagesContainer);
            }
            break;
        case "orama-button":
            if (!customElements.get(tagName)) {
                defineCustomElement$8();
            }
            break;
        case "orama-chat-assistent-message":
            if (!customElements.get(tagName)) {
                defineCustomElement$7();
            }
            break;
        case "orama-chat-user-message":
            if (!customElements.get(tagName)) {
                defineCustomElement$6();
            }
            break;
        case "orama-dots-loader":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "orama-markdown":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "orama-sources":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "orama-suggestions":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "orama-text":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { OramaChatMessagesContainer as O, defineCustomElement as d };
//# sourceMappingURL=p-B6vpyv53.js.map

//# sourceMappingURL=p-B6vpyv53.js.map