import { p as proxyCustomElement, H, h } from './p-BGpMMtbT.js';

const oramaFacetsCss = ".facets-list.sc-orama-facets{align-items:center;-moz-column-gap:.5rem;column-gap:.5rem;-moz-column-gap:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));column-gap:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));display:flex;list-style:none;margin:0;overflow-x:auto;padding:1rem;padding:var(--radius-l,calc(16rem/var(--orama-base-font-size, 16)));scroll-snap-type:y mandatory}.facets-list.sc-orama-facets::-webkit-scrollbar{background-color:transparent;height:0}@media (min-width:1024.02px){.facets-list.sc-orama-facets{padding:1rem .25rem .5rem;padding:var(--radius-l,calc(16rem/var(--orama-base-font-size, 16))) var(--radius-xs,calc(4rem/var(--orama-base-font-size, 16))) var(--radius-s,calc(8rem/var(--orama-base-font-size, 16)))}}.facet.sc-orama-facets{scroll-snap-align:start}.facet-button.sc-orama-facets{background-color:transparent;border:1px solid #dadada;border:1px solid var(--border-color-primary,#dadada);border-radius:2.5rem;border-radius:var(--radius-3xl,calc(40rem/var(--orama-base-font-size, 16)));color:#151515;color:var(--text-color-primary,#151515);-moz-column-gap:.25rem;column-gap:.25rem;-moz-column-gap:var(--spacing-xs,calc(4rem/var(--orama-base-font-size, 16)));column-gap:var(--spacing-xs,calc(4rem/var(--orama-base-font-size, 16)));cursor:pointer;display:flex;font-size:.875rem;font-size:var(--font-size-sm,calc(14rem/var(--orama-base-font-size, 16)));font-weight:400;font-weight:var(--font-weight-normal,400);line-height:1.25;line-height:var(--font-line-height-s,1.25);margin:0;padding:.5rem .75rem;padding:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16))) var(--spacing-m,calc(12rem/var(--orama-base-font-size, 16)));width:-moz-max-content;width:max-content}.facet-button--selected.sc-orama-facets{border-color:#432d77;border-color:var(--border-color-accent,#432d77)}@media (min-width:1024.02px){.facet-button.sc-orama-facets{padding:.25rem .75rem;padding:var(--spacing-xs,calc(4rem/var(--orama-base-font-size, 16))) var(--spacing-m,calc(12rem/var(--orama-base-font-size, 16)))}}.facet-button.sc-orama-facets:focus{border-color:#432d77;border-color:var(--border-color-accent,#432d77);outline:1px solid #432d77;outline:1px solid var(--border-color-accent,#432d77)}.facet-count.sc-orama-facets{color:#99989d;color:var(--text-color-tertiary,#99989d)}";

const OramaFacets = /*@__PURE__*/ proxyCustomElement(class OramaFacets extends H {
    constructor() {
        super();
        this.__registerHost();
    }
    handleClick(facet) {
        this.selectedFacetChanged(facet.name);
    }
    getFacetButtonElementId(facetName) {
        return `${facetName}-facet-button`;
    }
    setFocusToFacetElement(facetName) {
        const buttonList = this.facetListRef.getElementsByTagName('button');
        for (let i = 0; i < buttonList.length; i++) {
            if (buttonList.item(i).id === this.getFacetButtonElementId(facetName)) {
                buttonList.item(i).focus();
                return;
            }
        }
    }
    handleSelectedFacetChange() {
        var _a;
        this.setFocusToFacetElement(((_a = this.selectedFacet) === null || _a === void 0 ? void 0 : _a.length) ? this.selectedFacet : 'All');
    }
    handleKeyDown(ev) {
        if (['ArrowLeft', 'ArrowRight'].includes(ev.key)) {
            const index = this.selectedFacet ? this.facets.findIndex((facet) => facet.name === this.selectedFacet) : 0;
            if (ev.key === 'ArrowRight') {
                if (index < this.facets.length - 1) {
                    this.selectedFacetChanged(this.facets[index + 1].name);
                }
                else {
                    this.selectedFacetChanged('');
                }
            }
            if (ev.key === 'ArrowLeft') {
                if (index > 1) {
                    this.selectedFacetChanged(this.facets[index - 1].name);
                }
                else if (index - 1 === 0) {
                    this.selectedFacetChanged('');
                }
                else {
                    this.selectedFacetChanged(this.facets[this.facets.length - 1].name);
                }
            }
        }
    }
    render() {
        var _a;
        if (!this.facets || this.facets.every((facet) => !facet.count)) {
            return null;
        }
        return (h("ul", { class: "facets-list", ref: (el) => (this.facetListRef = el) }, (_a = this.facets) === null || _a === void 0 ? void 0 : _a.map((facet) => {
            if ((facet === null || facet === void 0 ? void 0 : facet.count) === 0) {
                return;
            }
            const isSelected = this.selectedFacet === (facet === null || facet === void 0 ? void 0 : facet.name) || (!this.selectedFacet && (facet === null || facet === void 0 ? void 0 : facet.name) === 'All');
            return (h("li", { key: facet.name, class: "facet" }, h("button", { id: this.getFacetButtonElementId(facet.name), type: "button", class: {
                    'facet-button': true,
                    'facet-button--selected': isSelected,
                }, tabIndex: isSelected ? 0 : -1, onClick: () => this.handleClick(facet) }, facet === null || facet === void 0 ? void 0 :
                facet.name, h("span", { class: "facet-count" }, facet === null || facet === void 0 ? void 0 : facet.count))));
        })));
    }
    static get watchers() { return {
        "selectedFacet": ["handleSelectedFacetChange"]
    }; }
    static get style() { return oramaFacetsCss; }
}, [2, "orama-facets", {
        "facets": [16],
        "selectedFacet": [1, "selected-facet"],
        "selectedFacetChanged": [16, "selected-facet-changed"]
    }, [[0, "keydown", "handleKeyDown"]], {
        "selectedFacet": ["handleSelectedFacetChange"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["orama-facets"];
    components.forEach(tagName => { switch (tagName) {
        case "orama-facets":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, OramaFacets);
            }
            break;
    } });
}

export { OramaFacets as O, defineCustomElement as d };
//# sourceMappingURL=p-BgN2hEjy.js.map

//# sourceMappingURL=p-BgN2hEjy.js.map