import { p as proxyCustomElement, H, c as createEvent, h, d as Host } from './p-BGpMMtbT.js';
import { S as Store } from './p-9VPaspy8.js';
import { g as getText } from './p-Db5sp_fc.js';
import { d as defineCustomElement$5 } from './p-BgN2hEjy.js';
import { d as defineCustomElement$4 } from './p-CegKHeec.js';
import { d as defineCustomElement$3 } from './p-CH-7DZ3H.js';
import { d as defineCustomElement$2 } from './p-9Kx-45gq.js';
import { d as defineCustomElement$1 } from './p-Ct9q51SM.js';

const oramaSearchCss = ".sc-orama-search-h{display:flex;flex-direction:column;overflow:hidden;width:100%}@media (max-width:1024px){.sc-orama-search-h orama-input.sc-orama-search{padding:0 1rem;padding:0 var(--spacing-l,calc(16rem/var(--orama-base-font-size, 16)))}}@media (max-width:1024px){.sc-orama-search-h{padding:.5rem 0;padding:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16))) 0}}.result-wrapper.sc-orama-search{flex-grow:1;overflow-y:auto;padding:0 1rem;padding:0 var(--spacing-l,calc(16rem/var(--orama-base-font-size, 16)))}.result-wrapper.sc-orama-search::-webkit-scrollbar{width:.3em}.result-wrapper.sc-orama-search::-webkit-scrollbar-track{background:transparent}.result-wrapper.sc-orama-search::-webkit-scrollbar-thumb{background-color:hsla(0,0%,70%,.522);border-radius:1rem;border-radius:var(--border-radius-l,calc(16rem/var(--orama-base-font-size, 16)))}@media (min-width:1024.02px){.result-wrapper.sc-orama-search{padding:0 .75rem;padding:0 var(--spacing-m,calc(12rem/var(--orama-base-font-size, 16)))}}.search-form.sc-orama-search{display:flex;flex-direction:column}";

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const OramaSearch = /*@__PURE__*/ proxyCustomElement(class OramaSearch extends H {
    constructor() {
        super();
        this.__registerHost();
        this.searchCompleted = createEvent(this, "searchCompleted");
        this.answerGenerated = createEvent(this, "answerGenerated");
        this.placeholder = 'Search...';
        this.focusInput = false;
        this.suggestions = [];
        this.disableChat = false;
        this.highlightTitle = false;
        this.highlightDescription = false;
        this.selectedFacet = '';
        this.handleSubmit = (e) => {
            e.preventDefault();
            if (this.disableChat) {
                return;
            }
            const chatButton = this.el.querySelector('orama-chat-button');
            chatButton === null || chatButton === void 0 ? void 0 : chatButton.click();
        };
    }
    /**
     * Gets the text for a specific key from the dictionary prop.
     * Prioritizes direct props (placeholder) for backward compatibility,
     * then falls back to the dictionary prop, and finally to the defaultTextDictionary.
     *
     * @param key - The key to get the text for
     * @returns The text for the specified key
     */
    getText(key) {
        // Create a map of direct props for backward compatibility
        const directProps = {
            searchPlaceholder: this.placeholder,
        };
        return getText(key, this.dictionary, directProps);
    }
    doSearch() {
        this.searchStore.state.searchService.search(this.globalStore.state.currentTerm, this.selectedFacet, {
            onSearchCompletedCallback: (onSearchCompletedCallbackProps) => {
                this.searchCompleted.emit(onSearchCompletedCallbackProps);
            },
        });
    }
    render() {
        var _a;
        return (h(Host, { key: '688c8af1ca2951057a901d4e5d93f44877f6e73b' }, h("form", { key: 'f08750150118e1417d817ead3024011a7dfa6d77', onSubmit: this.handleSubmit, class: "search-form" }, h("orama-input", { key: 'a173662d45226aa2e36f3ed12f5c3792d1f4aa86', "focus-on-arrow-nav": true, autoFocus: this.focusInput, type: "search", onInput: (e) => {
                const target = e.target;
                this.globalStore.state.currentTerm = target.value;
                this.doSearch();
            }, value: this.globalStore.state.currentTerm, size: "large", labelForScreenReaders: this.getText('searchPlaceholder'), placeholder: this.getText('searchPlaceholder') }), h("slot", { key: '64b40b9655e4bd2842800d0ca33e6cdaabf019cc', name: "summary" })), h("div", { key: '98f8fd718183e5436a2d42eabf8313d5b071be32', class: "result-wrapper" }, h("orama-facets", { key: '6dec4d3f30682444e46a18f3e31a6c77baf42f9c', facets: this.searchStore.state.facets, selectedFacet: this.selectedFacet, selectedFacetChanged: (facetName) => {
                this.selectedFacet = facetName;
                this.doSearch();
            } }), h("orama-search-results", { key: '7e8fe4f97b6882d503965c99044a4d5e46e649b7', suggestions: !((_a = this.globalStore.state.currentTerm) === null || _a === void 0 ? void 0 : _a.length) && !this.disableChat ? this.suggestions : [], setChatTerm: (term) => {
                var _a;
                this.globalStore.state.currentTask = 'chat';
                (_a = this.chatStore.state.chatService) === null || _a === void 0 ? void 0 : _a.sendQuestion(term, this.relatedQueries, undefined, {
                    onAnswerGeneratedCallback: (onAnswerGeneratedCallbackProps) => this.answerGenerated.emit(onAnswerGeneratedCallbackProps),
                });
            }, sourceBaseUrl: this.sourceBaseUrl, linksTarget: this.linksTarget, linksRel: this.linksRel, sections: this.searchStore.state.results, searchTerm: this.globalStore.state.currentTerm, highlightTitle: this.highlightTitle, highlightDescription: this.highlightDescription, loading: this.searchStore.state.loading, error: this.searchStore.state.error, dictionary: this.dictionary }))));
    }
    get el() { return this; }
    static get style() { return oramaSearchCss; }
}, [6, "orama-search", {
        "placeholder": [1],
        "focusInput": [4, "focus-input"],
        "suggestions": [16],
        "sourceBaseUrl": [1, "source-base-url"],
        "linksTarget": [1, "links-target"],
        "linksRel": [1, "links-rel"],
        "disableChat": [4, "disable-chat"],
        "relatedQueries": [2, "related-queries"],
        "highlightTitle": [4, "highlight-title"],
        "highlightDescription": [4, "highlight-description"],
        "dictionary": [16],
        "selectedFacet": [32]
    }]);
__decorate([
    Store('search')
], OramaSearch.prototype, "searchStore", void 0);
__decorate([
    Store('global')
], OramaSearch.prototype, "globalStore", void 0);
__decorate([
    Store('chat')
], OramaSearch.prototype, "chatStore", void 0);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["orama-search", "orama-facets", "orama-input", "orama-search-results", "orama-suggestions", "orama-text"];
    components.forEach(tagName => { switch (tagName) {
        case "orama-search":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, OramaSearch);
            }
            break;
        case "orama-facets":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "orama-input":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "orama-search-results":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "orama-suggestions":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "orama-text":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { OramaSearch as O, defineCustomElement as d };
//# sourceMappingURL=p-BndWlfiB.js.map

//# sourceMappingURL=p-BndWlfiB.js.map