import { p as proxyCustomElement, H, h, d as Host } from './p-BGpMMtbT.js';
import { I as Icon } from './p-CxEuuiI6.js';
import { c as getNonExplicitAttributes } from './p-BQsBOb3k.js';
import './p-D6ogEMIP.js';

const oramaChatButtonCss = "@keyframes shine{0%{background-position:0 50%}to{background-position:150%;opacity:0}}@keyframes animBg{0%{background:#eee9f6;background:var(--background-color-tertiary,#eee9f6)}70%{background:#eee9f6;background:var(--background-color-tertiary,#eee9f6)}to{background:transparent}}@keyframes steam{0%{background-position:0 50%}50%{background-position:75% 50%}to{background-position:0 50%}}.sc-orama-chat-button-h{border-bottom:1px solid #dadada;border-bottom:1px solid var(--border-color-primary,#dadada);padding:.5rem;padding:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)))}.chat-button.sc-orama-chat-button{align-items:center;background:transparent;border:1px solid transparent;border-radius:.5rem;border-radius:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));color:#151515;color:var(--text-color-primary,#151515);cursor:pointer;display:flex;font-size:1rem;font-size:var(--font-size-md,calc(16rem/var(--orama-base-font-size, 16)));font-weight:400;font-weight:var(--font-weight-normal,400);gap:.5rem;gap:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));line-height:1.5;line-height:var(--font-line-height-m,1.5);margin:0;padding:.5rem;padding:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));position:relative;width:100%}@media (min-width:768.02px){.chat-button.sc-orama-chat-button{font-size:.875rem;font-size:var(--font-size-sm,calc(14rem/var(--orama-base-font-size, 16)))}}@media (hover:hover){.chat-button.sc-orama-chat-button:hover{background:#eee9f6;background:var(--background-color-tertiary,#eee9f6)}}.chat-button.sc-orama-chat-button:focus-visible{border:1px solid #432d77;border:1px solid var(--border-color-accent,#432d77);outline:none}.chat-button.is-active.sc-orama-chat-button{background:#eee9f6;background:var(--background-color-tertiary,#eee9f6)}.chat-button.is-highlighted.sc-orama-chat-button:after,.chat-button.is-highlighted.sc-orama-chat-button:before{animation:shine 1s linear 1 forwards;background:linear-gradient(90deg,transparent 0,transparent 20%,#432d77 40%,#432d77 60%,transparent 80%,transparent);background:linear-gradient(to right,var(--chat-button-border-color-gradientOne,transparent) 0,var(--chat-button-border-color-gradientTwo,transparent) 20%,var(--chat-button-border-color-gradientThree,#432d77) 40%,var(--chat-button-border-color-gradientFour,#432d77) 60%,var(--chat-button-border-color-gradientFive,transparent) 80%,var(--chat-button-border-color-gradientSix,transparent) 100%);background-size:150% auto;border-radius:.5rem;border-radius:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));content:\"\";display:block;height:calc(100% + 4px);left:-2px;overflow:hidden;position:absolute;top:-2px;width:calc(100% + 4px);z-index:-1}.chat-button.is-highlighted.sc-orama-chat-button:after{filter:blur(3px);height:100%;width:100%}.icon-star.sc-orama-chat-button{align-items:center;background:linear-gradient(79deg,#432d77 -45%,transparent 75%);background:linear-gradient(79deg,var(--chat-button-background-color-gradientOne,#432d77) -45%,var(--chat-button-backgroun-color-gradientTwo,transparent) 75%);background-size:200% auto;border-radius:.375rem;border-radius:var(--radius-xs,calc(6rem/var(--orama-base-font-size, 16)));display:flex;padding:.5rem;padding:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)))}.is-highlighted.sc-orama-chat-button .icon-star.sc-orama-chat-button{animation:steam 1.4s linear 1 forwards}.icon-enter.sc-orama-chat-button{align-items:center;border:.7px solid #dadada;border:.7px solid var(--border-color-primary,#dadada);border-radius:.375rem;border-radius:var(--radius-xs,calc(6rem/var(--orama-base-font-size, 16)));display:flex;justify-self:flex-end;padding:.25rem;padding:var(--spacing-xs,calc(4rem/var(--orama-base-font-size, 16)))}.button-label.sc-orama-chat-button{flex-grow:1;text-align:left}";

const OramaChatButton = /*@__PURE__*/ proxyCustomElement(class OramaChatButton extends H {
    constructor() {
        super();
        this.__registerHost();
        this.active = false;
        this.highlight = false;
    }
    highlightButton() {
        if (this.active && !this.highlight) {
            this.highlight = true;
        }
    }
    render() {
        const declaredProps = ['label', 'onClick', 'class'];
        const buttonProps = getNonExplicitAttributes(this.el, declaredProps);
        return (h(Host, { key: 'cc45b1355726ff5bf65b39f4243f6f0d227d0c80', class: this.class }, h("button", Object.assign({ key: '4a312f0e559412dee000149b4f3cf74cfe858c0e', class: {
                'chat-button': true,
                'is-active': this.active,
                'is-highlighted': this.highlight,
            } }, buttonProps, { type: "button" }), h("span", { key: '9a10019c4b275d05978ecad9abcffb058d782943', class: "icon-star" }, h(Icon, { key: '82edfc1787227fb15f3fefedecf57e2a0e74d8b3', name: "star", size: 16 })), h("span", { key: '13e4d54e9296f513735f6081caaf060cc9511905', class: "button-label" }, this.label), h("span", { key: '3c98e473b7b88034a316590bae6de3d1c1ca4dd4', class: "icon-enter" }, h("ph-arrow-bend-down-left", { key: '36f9ce444b33abaef5cfdf81d0d0d2b199f8590f', size: 12 })))));
    }
    get el() { return this; }
    static get watchers() { return {
        "active": ["highlightButton"],
        "highlight": ["highlightButton"]
    }; }
    static get style() { return oramaChatButtonCss; }
}, [2, "orama-chat-button", {
        "label": [1],
        "active": [4],
        "highlight": [1028],
        "class": [1]
    }, undefined, {
        "active": ["highlightButton"],
        "highlight": ["highlightButton"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["orama-chat-button"];
    components.forEach(tagName => { switch (tagName) {
        case "orama-chat-button":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, OramaChatButton);
            }
            break;
    } });
}

export { OramaChatButton as O, defineCustomElement as d };
//# sourceMappingURL=p-CTt88pb0.js.map

//# sourceMappingURL=p-CTt88pb0.js.map