import { p as proxyCustomElement, H, c as createEvent, h, d as Host } from './p-BGpMMtbT.js';
import './p-BGecKD1h.js';
import './p-DXSoIv40.js';
import { c as getNonExplicitAttributes } from './p-BQsBOb3k.js';

const oramaInputCss = ".sc-orama-input-h{margin:.5rem 0;margin:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16))) 0}.input-wrapper.sc-orama-input{position:relative}.input.sc-orama-input{background:#fff;background:var(--background-color-secondary,#fff);border:1px solid #dadada;border:1px solid var(--border-color-primary,#dadada);border-radius:.75rem;border-radius:var(--radius-m,calc(12rem/var(--orama-base-font-size, 16)));color:#151515;color:var(--text-color-primary,#151515);font-size:1rem;font-size:var(--font-size-md,calc(16rem/var(--orama-base-font-size, 16)));font-weight:400;font-weight:var(--font-weight-normal,400);line-height:1.5;line-height:var(--font-line-height-m,1.5);margin:0;padding:0;width:100%}@media (min-width:768.02px){.input.sc-orama-input{font-size:.875rem;font-size:var(--font-size-sm,calc(14rem/var(--orama-base-font-size, 16)))}}.input.sc-orama-input::-moz-placeholder{color:#99989d;color:var(--text-color-inactive,#99989d)}.input.sc-orama-input::placeholder{color:#99989d;color:var(--text-color-inactive,#99989d)}.input[type=search].sc-orama-input{padding-right:2rem;padding-right:var(--spacing-2xl,calc(32rem/var(--orama-base-font-size, 16)))}@media (min-width:1024.02px){.input[type=search].sc-orama-input{border:0;border-bottom:1px solid #dadada;border-bottom:1px solid var(--border-color-primary,#dadada);padding-left:2.5rem;padding-left:var(--spacing-3xl,calc(40rem/var(--orama-base-font-size, 16)))}}.input[type=search].sc-orama-input::-webkit-search-cancel-button,.input[type=search].sc-orama-input::-webkit-search-decoration{-webkit-appearance:none;appearance:none}.input.sc-orama-input:focus{outline:none}.input.sc-orama-input:focus-visibile{border:1px solid #432d77;border:1px solid var(--border-color-accent,#432d77);outline:none}.input--small.sc-orama-input{padding:.25rem .5rem;padding:var(--spacing-xs,calc(4rem/var(--orama-base-font-size, 16))) var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)))}.input--medium.sc-orama-input{padding:.5rem;padding:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)))}.input--large.sc-orama-input{padding:.75rem;padding:var(--spacing-m,calc(12rem/var(--orama-base-font-size, 16)))}.label.sc-orama-input{color:#151515;color:var(--text-color-primary,#151515);display:block;font-size:.875rem;font-size:var(--font-size-sm,calc(14rem/var(--orama-base-font-size, 16)));font-weight:400;font-weight:var(--font-weight-normal,400);line-height:1.25;line-height:var(--font-line-height-s,1.25);margin:0 0 .25rem;margin-bottom:var(--spacing-xs,calc(4rem/var(--orama-base-font-size, 16)));padding:0}.reset-button.sc-orama-input{background-color:transparent;border:0;color:#99989d;color:var(--icon-color-inactive,#99989d);cursor:pointer;display:inline-flex;position:absolute;right:.5rem;right:var(--spacing-s,calc(8rem/var(--orama-base-font-size, 16)));top:50%;transform:translate3d(0,-50%,0)}.reset-button.sc-orama-input:focus{outline:none}.reset-button.sc-orama-input:focus-visible{border:1px solid #432d77;border:1px solid var(--border-color-accent,#432d77)}.search-icon.sc-orama-input{color:#99989d;color:var(--icon-color-inactive,#99989d);display:none;left:1rem;left:var(--spacing-l,calc(16rem/var(--orama-base-font-size, 16)));position:absolute;top:50%;transform:translate3d(0,-50%,0);z-index:100}@media (min-width:1024.02px){.search-icon.sc-orama-input{display:inline-flex}}.sr-only.sc-orama-input{clip:rect(0 0 0 0);clip-path:inset(50%);height:1px;overflow:hidden;position:absolute;white-space:nowrap;width:1px}";

const Input = /*@__PURE__*/ proxyCustomElement(class Input extends H {
    constructor() {
        super();
        this.__registerHost();
        this.inputChanged = createEvent(this, "inputChanged");
        this.size = 'medium';
        this.type = 'text';
        this.autoFocus = false;
    }
    handleAutoFocusChange() {
        var _a;
        if (this.autoFocus) {
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        }
    }
    ensureFocus() {
        const checkRefInterval = setInterval(() => {
            if (this.inputRef) {
                this.inputRef.focus();
                clearInterval(checkRefInterval);
            }
        }, 10);
    }
    componentDidLoad() {
        if (this.autoFocus) {
            this.ensureFocus();
        }
    }
    render() {
        const inputClass = `input input--${this.size}`;
        const labelClass = `label ${this.labelForScreenReaders ? 'sr-only' : ''}`;
        const declaredProps = [
            'id',
            'name',
            'type',
            'class',
            'onInput',
            'value',
            'label-for-screen-readers',
            'default-value',
            'placeholder',
        ];
        const inputProps = getNonExplicitAttributes(this.el, declaredProps);
        const isSearch = this.type === 'search';
        return (h(Host, { key: '2618def598b4bcffcb974d761937c304f36d70cf' }, h("div", { key: '07b0b637d645dfcd43dab6f20256b548f42672bb', class: "wrapper" }, h("label", { key: 'c8e3e0ee0962064c613ccbfa459873e8e80ee32a', htmlFor: this.name, class: labelClass }, this.label || this.labelForScreenReaders), h("div", { key: '7c78f6d5e491b17094d86ef89c4461178e1e620c', class: "input-wrapper" }, isSearch && (h("span", { key: '07a43ba5606596d2b2834bb3dc040573d7039a05', class: "search-icon" }, h("ph-magnifying-glass", { key: '3097468ab3864e7a29121e5f5978cf6f4a14f006', size: 16 }))), h("input", Object.assign({ key: '5ee32af4e927d3f717345a2d2337793ba28d9c43' }, inputProps, { ref: (el) => {
                this.inputRef = el;
            }, class: inputClass, id: this.name, type: this.type, value: this.value, onInput: (event) => {
                const target = event.target;
                this.inputChanged.emit(target.value);
            }, placeholder: this.placeholder })), isSearch && !!this.value && (h("button", { key: '13c7ee67fdafb756fda92b7d7739fccc367b8f20', type: "button", class: "reset-button", onClick: () => {
                this.inputRef.focus();
                this.inputChanged.emit('');
            } }, h("ph-x", { key: 'b24dec02e1a86d9205ee4a4025472571ac941fbe', size: 16 })))))));
    }
    get el() { return this; }
    static get watchers() { return {
        "autoFocus": ["handleAutoFocusChange"]
    }; }
    static get style() { return oramaInputCss; }
}, [2, "orama-input", {
        "name": [1],
        "size": [1],
        "label": [1],
        "type": [1],
        "placeholder": [1],
        "labelForScreenReaders": [1, "label-for-screen-readers"],
        "defaultValue": [1, "default-value"],
        "autoFocus": [4, "auto-focus"],
        "value": [1]
    }, undefined, {
        "autoFocus": ["handleAutoFocusChange"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["orama-input"];
    components.forEach(tagName => { switch (tagName) {
        case "orama-input":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, Input);
            }
            break;
    } });
}

export { Input as I, defineCustomElement as d };
//# sourceMappingURL=p-CegKHeec.js.map

//# sourceMappingURL=p-CegKHeec.js.map