import { p as proxyCustomElement, H, h } from './p-BGpMMtbT.js';
import { c as getNonExplicitAttributes } from './p-BQsBOb3k.js';

const oramaTextCss = ".p.sc-orama-text{color:#151515;color:var(--text-color-primary,#151515);font-size:1rem;font-size:var(--font-size-md,calc(16rem/var(--orama-base-font-size, 16)));font-weight:400;font-weight:var(--font-weight-normal,400);line-height:1.5;line-height:var(--font-line-height-m,1.5);margin:0;padding:0}@media (min-width:768.02px){.p.sc-orama-text{font-size:.875rem;font-size:var(--font-size-sm,calc(14rem/var(--orama-base-font-size, 16)))}}.p-secondary.sc-orama-text{color:#838289;color:var(--text-color-secondary,#838289);font-size:1rem;font-size:var(--font-size-md,calc(16rem/var(--orama-base-font-size, 16)));font-weight:400;font-weight:var(--font-weight-normal,400);line-height:1.5;line-height:var(--font-line-height-m,1.5);margin:0;padding:0}@media (min-width:768.02px){.p-secondary.sc-orama-text{font-size:.875rem;font-size:var(--font-size-sm,calc(14rem/var(--orama-base-font-size, 16)))}}.p-tertiary.sc-orama-text{color:#99989d;color:var(--text-color-tertiary,#99989d);font-size:1rem;font-size:var(--font-size-md,calc(16rem/var(--orama-base-font-size, 16)));font-weight:400;font-weight:var(--font-weight-normal,400);line-height:1.5;line-height:var(--font-line-height-m,1.5);margin:0;padding:0}@media (min-width:768.02px){.p-tertiary.sc-orama-text{font-size:.875rem;font-size:var(--font-size-sm,calc(14rem/var(--orama-base-font-size, 16)))}}.span.sc-orama-text{color:#151515;color:var(--text-color-primary,#151515)}.span.sc-orama-text,.span-secondary.sc-orama-text{font-size:.875rem;font-size:var(--font-size-sm,calc(14rem/var(--orama-base-font-size, 16)));font-weight:400;font-weight:var(--font-weight-normal,400);line-height:1.25;line-height:var(--font-line-height-s,1.25);margin:0;padding:0}.span-secondary.sc-orama-text{color:#838289;color:var(--text-color-secondary,#838289)}.span-tertiary.sc-orama-text{color:#99989d;color:var(--text-color-tertiary,#99989d);font-size:.875rem;font-size:var(--font-size-sm,calc(14rem/var(--orama-base-font-size, 16)));font-weight:400;font-weight:var(--font-weight-normal,400);line-height:1.25;line-height:var(--font-line-height-s,1.25);margin:0;padding:0}.small.sc-orama-text{color:#151515;color:var(--text-color-primary,#151515)}.small.sc-orama-text,.small-secondary.sc-orama-text{font-size:.75rem;font-size:var(--font-size-xs,calc(12rem/var(--orama-base-font-size, 16)));font-weight:400;font-weight:var(--font-weight-normal,400);line-height:1.25;line-height:var(--font-line-height-s,1.25);margin:0;padding:0}.small-secondary.sc-orama-text{color:#838289;color:var(--text-color-secondary,#838289)}.small-tertiary.sc-orama-text{color:#99989d;color:var(--text-color-tertiary,#99989d);font-size:.75rem;font-size:var(--font-size-xs,calc(12rem/var(--orama-base-font-size, 16)));font-weight:400;font-weight:var(--font-weight-normal,400);line-height:1.25;line-height:var(--font-line-height-s,1.25);margin:0;padding:0}.text-bold.sc-orama-text{font-weight:600;font-weight:var(--font-weight-semibold,600)}.text-left.sc-orama-text{text-align:left}.text-right.sc-orama-text{text-align:right}.text-center.sc-orama-text{text-align:center}.text-inactive.sc-orama-text{color:#99989d;color:var(--text-color-inactive,#99989d)}";

const OramaText = /*@__PURE__*/ proxyCustomElement(class OramaText extends H {
    constructor() {
        super();
        this.__registerHost();
        this.as = 'p';
        this.bold = false;
        this.variant = 'primary';
    }
    render() {
        const defaultStyle = this.styledAs === 'span' || this.styledAs === 'small' || this.styledAs === 'p' ? this.styledAs : this.as;
        const Tag = this.as;
        const declaredProps = ['as', 'styled-as', 'class'];
        const textProps = getNonExplicitAttributes(this.el, declaredProps);
        return (h(Tag, Object.assign({ key: 'a1c41477fc4643a8fd1eba038a39117311e17a20', class: {
                [defaultStyle]: true,
                [`text-${this.align}`]: !!this.align,
                [`${defaultStyle}-${this.variant}`]: true,
                'text-inactive': !!this.inactive,
                'text-bold': !!this.bold,
                [this.class]: !!this.class,
            } }, textProps), h("slot", { key: 'd78c56927befa49cf5f54ab77dd76c9ab3797770' })));
    }
    get el() { return this; }
    static get style() { return oramaTextCss; }
}, [6, "orama-text", {
        "as": [1],
        "styledAs": [1, "styled-as"],
        "bold": [4],
        "class": [1],
        "align": [1],
        "variant": [1],
        "inactive": [4]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["orama-text"];
    components.forEach(tagName => { switch (tagName) {
        case "orama-text":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, OramaText);
            }
            break;
    } });
}

export { OramaText as O, defineCustomElement as d };
//# sourceMappingURL=p-Ct9q51SM.js.map

//# sourceMappingURL=p-Ct9q51SM.js.map