import { p as proxyCustomElement, H, c as createEvent, h } from './p-BGpMMtbT.js';

const oramaModalCss = ".modal.sc-orama-modal{background-color:hsla(0,0%,98%,.7);background-color:var(--backdrop-background-color-primary,hsla(0,0%,98%,.7));display:none;height:100%;left:0;position:fixed;top:0;width:100%;z-index:9999}.modal.open.sc-orama-modal{display:block}dialog.sc-orama-modal{border:none}.modal-content.sc-orama-modal{background-color:#fbfbfb;background-color:var(--background-color-primary,#fbfbfb);display:flex;flex-direction:column;inset:0;justify-content:space-between;position:fixed}@media (min-width:1024.02px){.modal-content.sc-orama-modal{background-color:#fff;background-color:var(--background-color-secondary,#fff);border:1px solid #dadada;border:1px solid var(--border-color-primary,#dadada);border-radius:.75rem;border-radius:var(--radius-m,calc(12rem/var(--orama-base-font-size, 16)));bottom:auto;margin:0 auto;max-height:70vh;max-width:45rem;max-width:calc(720rem/var(--orama-base-font-size, 16));min-height:12.5rem;min-height:calc(200rem/var(--orama-base-font-size, 16));padding:0;top:5vh;width:80%}}.modal-close.sc-orama-modal:not(:focus-visible){clip:rect(0 0 0 0);clip-path:inset(50%);height:1px;overflow:hidden;position:absolute;white-space:nowrap;width:1px}.modal-title.sc-orama-modal{clip:rect(0 0 0 0);clip-path:inset(50%);height:1px;overflow:hidden;position:absolute;white-space:nowrap;width:1px}";

const OramaModal = /*@__PURE__*/ proxyCustomElement(class OramaModal extends H {
    constructor() {
        super();
        this.__registerHost();
        this.modalClosed = createEvent(this, "modalClosed");
        this.closeOnEscape = true;
        this.closeOnOutsideClick = true;
        this.mainTitle = '';
        this.originalBodyOverflowState = 'scroll';
    }
    trapFocus(event) {
        const focusableElements = this.el.querySelectorAll('a[href], button, textarea, input, select, [tabindex]:not([tabindex="-1"])');
        const focusableArray = Array.from(focusableElements).filter((element) => element.offsetParent !== null);
        if (focusableArray.length > 0) {
            this.firstFocusableElement = focusableArray[0];
            this.lastFocusableElement = focusableArray[focusableArray.length - 1];
            const focusedElement = this.el.querySelector(':focus');
            if (event.shiftKey && focusedElement === this.firstFocusableElement) {
                event.preventDefault();
                this.lastFocusableElement.focus();
            }
            else if (!event.shiftKey && focusedElement === this.lastFocusableElement) {
                event.preventDefault();
                this.firstFocusableElement.focus();
            }
        }
    }
    handleFocus() {
        const focusableElements = this.el.querySelectorAll('a[href], button, textarea, input, select, [tabindex]:not([tabindex="-1"])');
        const focusableArray = Array.from(focusableElements).filter((element) => element.offsetParent !== null);
        if (focusableArray.length > 0) {
            focusableArray[0].focus();
        }
    }
    connectedCallback() {
        this.originalBodyOverflowState = document.body.style.overflow;
        this.activeElement = document.activeElement;
        this.handleFocus();
        document.body.style.overflow = 'hidden';
    }
    disconnectedCallback() {
        document.body.style.overflow = this.originalBodyOverflowState;
    }
    componentDidUpdate() {
        this.handleFocus();
        if (this.activeElement) {
            this.activeElement.focus();
        }
    }
    render() {
        return (h("dialog", { key: 'a3fc3367ed30a5b2c440df67600bf619652b559c', class: 'modal open', "aria-modal": "true", "aria-labelledby": "modalTitle", "aria-describedby": "modalContent", onKeyDown: (event) => {
                switch (event.key) {
                    case 'Tab':
                        this.trapFocus(event);
                        break;
                    case 'Escape':
                        if (this.closeOnEscape) {
                            event.preventDefault();
                            event.stopPropagation();
                            this.modalClosed.emit();
                        }
                        break;
                }
            }, onClick: (event) => {
                if (this.innerModalRef && !this.innerModalRef.contains(event.target)) {
                    event.stopPropagation();
                    event.preventDefault();
                    this.modalClosed.emit();
                }
            } }, h("div", { key: '4eff2c8624762dc014b85851590abed2cf8f38c3', class: "modal-inner", ref: (ref) => (this.innerModalRef = ref) }, h("h1", { key: 'd4360fef432f56884b54c5bdfac5d8bfa6e530ef', id: "modalTitle", class: "modal-title" }, this.mainTitle), h("div", { key: '9e3867727679699c7d31e71b7d637c6d4cb24334', id: "modalContent", class: "modal-content" }, h("slot", { key: 'deb12898e6327dc99b52ae8d48444c0d09b2320d' })), h("button", { key: '43dfa57f3117c030474c707113208aa954cf68f4', onClick: () => this.modalClosed.emit(), type: "button", class: "modal-close" }, "Close"))));
    }
    get el() { return this; }
    static get style() { return oramaModalCss; }
}, [6, "orama-modal", {
        "closeOnEscape": [4, "close-on-escape"],
        "closeOnOutsideClick": [4, "close-on-outside-click"],
        "mainTitle": [1, "main-title"],
        "activeElement": [32]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["orama-modal"];
    components.forEach(tagName => { switch (tagName) {
        case "orama-modal":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, OramaModal);
            }
            break;
    } });
}

export { OramaModal as O, defineCustomElement as d };
//# sourceMappingURL=p-D12Opl02.js.map

//# sourceMappingURL=p-D12Opl02.js.map