import { p as proxyCustomElement, H, h, F as Fragment } from './p-BGpMMtbT.js';
import './p-BGecKD1h.js';

const oramaSlidingPanelCss = ".slide-backdrop.visible.sc-orama-sliding-panel{animation:backdropFadeIn .5s ease-in 1;background-color:hsla(0,0%,98%,.7);background-color:var(--backdrop-background-color-primary,hsla(0,0%,98%,.7));display:none;display:block;height:100vh;left:0;opacity:0;position:fixed;top:0;width:100vw;z-index:10009}@media (min-width:1024.02px){.slide-backdrop.visible.sc-orama-sliding-panel{display:block;opacity:1}}@keyframes backdropFadeIn{0%{opacity:0}50%{opacity:.2}to{opacity:1}}.slide-container.sc-orama-sliding-panel{background-color:#fbfbfb;background-color:var(--background-color-primary,#fbfbfb);border:1px solid #dadada;border:1px solid var(--border-color-primary,#dadada);border-radius:.75rem .75rem 0 0;border-radius:var(--radius-m,calc(12rem/var(--orama-base-font-size, 16))) var(--radius-m,calc(12rem/var(--orama-base-font-size, 16))) 0 0;bottom:0;box-sizing:border-box;color:#151515;color:var(--text-color-primary,#151515);height:95vh;left:0;position:fixed;transform:translate3d(0,calc(100% + 5vh),0);transition:.4s cubic-bezier(.4,0,.2,1);width:100%;z-index:10019}.slide-container.slide-up.sc-orama-sliding-panel{transform:translateZ(0)}@media (max-width:1024px){.slide-container.sc-orama-sliding-panel{display:none}}.slide-container-inner.sc-orama-sliding-panel{height:95vh;margin:0 auto;max-width:52.5rem;max-width:calc(840rem/var(--orama-base-font-size, 16));width:80%}.slide-container-inner.sc-orama-sliding-panel orama-chat.sc-orama-sliding-panel{height:100%}.slide-container-header.sc-orama-sliding-panel{box-sizing:border-box;display:flex;height:5vh;justify-content:flex-end;padding:0 2.5rem;padding:0 var(--spacing-3xl,calc(40rem/var(--orama-base-font-size, 16)));position:absolute;top:-5vh;width:100%}.close-button.sc-orama-sliding-panel{animation:showIn .3s cubic-bezier(.4,0,.2,1) .1s forwards;background-color:transparent;border:0;color:#151515;color:var(--text-color-primary,#151515);cursor:pointer}";

const SlideInPanel = /*@__PURE__*/ proxyCustomElement(class SlideInPanel extends H {
    constructor() {
        super();
        this.__registerHost();
        this.backdrop = false;
        this.open = false;
        this.isOpen = this.open;
    }
    openChanged() {
        this.isOpen = this.open;
    }
    closePanel() {
        if (this.closed) {
            this.closed();
        }
        this.isOpen = false;
    }
    trapFocus(event) {
        var _a;
        const focusableElements = (_a = this.el) === null || _a === void 0 ? void 0 : _a.querySelectorAll('a[href], button, textarea, input, select, [tabindex]:not([tabindex="-1"])');
        let focusableArray = Array.from(focusableElements);
        focusableArray = focusableArray.filter((element) => element.tabIndex !== -1);
        if (focusableArray.length > 0) {
            this.firstFocusableElement = focusableArray[0];
            this.lastFocusableElement = focusableArray[focusableArray.length - 1];
            const focusedElement = this.el.querySelector(':focus');
            if (event.shiftKey && focusedElement === this.firstFocusableElement) {
                event.preventDefault();
                this.lastFocusableElement.focus();
            }
            else if (!event.shiftKey && focusedElement === this.lastFocusableElement) {
                event.preventDefault();
                this.firstFocusableElement.focus();
            }
        }
    }
    handleKeyDown(event) {
        event.stopPropagation();
        if (event.key === 'Escape') {
            this.closePanel();
        }
        if (event.key === 'Tab') {
            this.trapFocus(event);
        }
    }
    componentDidLoad() {
        this.isOpen = this.open;
    }
    render() {
        return (h(Fragment, { key: 'f88b00bf1fc61de9416fcbfe6401ff14d7865fd2' }, h("div", { key: 'dba8338860b889ca1bed7bf25de95be366f0a2f4', class: { 'slide-container': true, 'slide-up': this.isOpen }, tabIndex: this.isOpen ? 0 : -1 }, h("div", { key: '1f7b7c593782897ca63527c93cf775985f3682d2', class: "slide-container-header" }, h("button", { key: '08826ac5dc073eba459dd2fd9adbbe34521c48a5', onClick: () => this.closePanel(), "aria-expanded": this.isOpen ? 'true' : 'false', "aria-label": "Close panel", "aria-controls": "panel", class: "close-button", type: "button" }, h("ph-x", { key: 'e1f618268881eeb161291e7b25accdc9835e453a', size: "18" }))), h("div", { key: 'd032def08d136efb85b7dcc203b855c211024537', id: "panel", "aria-hidden": !this.isOpen, tabindex: "-1", class: "slide-container-inner" }, h("slot", { key: '63db6812e71a0cc1a7fd0bc630a5200632908562' }))), this.backdrop && h("div", { key: 'a1da61d3366e055e2c3bb40cc60dd2ad14a8e9ac', class: { 'slide-backdrop': true, visible: this.isOpen } })));
    }
    get el() { return this; }
    static get watchers() { return {
        "open": ["openChanged"]
    }; }
    static get style() { return oramaSlidingPanelCss; }
}, [6, "orama-sliding-panel", {
        "backdrop": [4],
        "open": [4],
        "closed": [16],
        "isOpen": [32]
    }, [[4, "keydown", "handleKeyDown"]], {
        "open": ["openChanged"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["orama-sliding-panel"];
    components.forEach(tagName => { switch (tagName) {
        case "orama-sliding-panel":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, SlideInPanel);
            }
            break;
    } });
}

export { SlideInPanel as S, defineCustomElement as d };
//# sourceMappingURL=p-DDcIPJdp.js.map

//# sourceMappingURL=p-DDcIPJdp.js.map