import { type ChatStoreType } from "./ChatStore";
import { type GlobalStoreType } from "./GlobalStore";
import { type SearchStoreType } from "./SearchStore";
export type StoresMapType = {
    global?: GlobalStoreType;
    search?: SearchStoreType;
    chat?: ChatStoreType;
};
export type StoresMapKeys = keyof StoresMapType;
export declare const initStore: <T extends StoresMapKeys>(storeName: T, parentComponentId: string) => StoresMapType[T];
export declare const removeAllStores: (parentComponentId: string) => void;
export declare function getStore<T extends StoresMapKeys>(storeName: T, element: HTMLElement): StoresMapType[T];
