import type { SearchService } from "../services/SearchService";
import type { Facet, ResultMap, SearchResultBySection } from "../types/index";
import type { AnyOrama, Orama, SearchParams } from '@orama/orama';
import type { OramaClient } from '@oramacloud/client';
import type { ObservableMap } from '@stencil/store';
export declare const SearchStoreInitialProps: {
    count: number;
    facets: Facet[];
    facetProperty: string;
    results: SearchResultBySection[];
    resultMap: ResultMap;
    highlightedIndex: number;
    loading: boolean;
    error: boolean;
    searchService: SearchService | null;
    searchParams: SearchParams<Orama<AnyOrama | OramaClient>>;
};
export type SearchStoreType = ObservableMap<typeof SearchStoreInitialProps>;
