type BaseProps = {
    /** the optional class name */
    class?: string;
    /** the style variant of the button - default is primary */
    variant?: 'primary' | 'secondary' | 'icon';
};
type ConditionalProps = {
    /** it defines the HTML tag to be used */
    as?: 'button';
    type: 'button' | 'submit' | 'reset';
} | {
    /** it defines the HTML tag to be used */
    as?: 'a';
    href: string;
    type?: never;
};
export type ButtonProps = BaseProps & ConditionalProps;
export declare class OramaButton {
    el: HTMLButtonElement | HTMLAnchorElement;
    as?: ButtonProps['as'];
    class?: string;
    variant?: ButtonProps['variant'];
    size: 'small' | 'medium' | 'large';
    type?: ButtonProps['type'];
    disabled?: boolean;
    withTooltip?: string;
    render(): any;
}
export {};
