import { type EventEmitter } from '../../../stencil-public-runtime';
import '@phosphor-icons/webcomponents/dist/icons/PhX.mjs';
import '@phosphor-icons/webcomponents/dist/icons/PhMagnifyingGlass.mjs';
type BaseInputProps = {
    name?: string;
    size?: 'small' | 'medium' | 'large';
    type?: 'text' | 'password' | 'email' | 'number' | 'tel' | 'url' | 'search';
    placeholder?: string;
    defaultValue?: string;
};
type ConditionalInputProps = {
    label: string;
    labelForScreenReaders?: never;
} | {
    label?: never;
    labelForScreenReaders?: string;
};
export type InputProps = BaseInputProps & ConditionalInputProps;
export declare class Input {
    el: HTMLDivElement;
    name: InputProps['name'];
    size?: InputProps['size'];
    label?: InputProps['label'];
    type?: InputProps['type'];
    placeholder?: InputProps['placeholder'];
    labelForScreenReaders?: InputProps['labelForScreenReaders'];
    defaultValue: InputProps['defaultValue'];
    autoFocus?: boolean;
    value?: string;
    inputChanged: EventEmitter<string>;
    private inputRef;
    handleAutoFocusChange(): void;
    ensureFocus(): void;
    componentDidLoad(): void;
    render(): any;
}
export {};
