import { type EventEmitter } from '../../../stencil-public-runtime';
import type { OnSearchResultClickCallbackProps, SearchResult, SearchResultBySection, Dictionary } from "../../../types/index";
import { Highlight } from '@orama/highlight';
import type { HighlightOptions } from '@orama/highlight';
import '@phosphor-icons/webcomponents/dist/icons/PhFiles.mjs';
export type SearchResultsProps = {
    sections: SearchResultBySection[];
    searchTerm?: string;
};
export declare class SearchResults {
    el: HTMLUListElement;
    sourceBaseUrl?: string;
    linksTarget?: string;
    linksRel?: string;
    sections: SearchResultBySection[];
    suggestions?: string[];
    searchTerm: SearchResultsProps['searchTerm'];
    setChatTerm: (term: string) => void;
    loading: boolean;
    error: boolean;
    highlightTitle?: HighlightOptions | false;
    highlightDescription?: HighlightOptions | false;
    dictionary?: Partial<Dictionary>;
    searchResultClick: EventEmitter<OnSearchResultClickCallbackProps>;
    private highlighterTitle?;
    private highlighterDescription?;
    private buildUrl;
    handleItemClick: (originalOnClickEvent: MouseEvent, item: SearchResult) => void;
    getItemLinkUrl: (item: SearchResult) => string;
    getHighlightedTitleText: (text: string) => Highlight;
    getHighlightedDescriptionText: (text: string) => Highlight;
    componentDidLoad(): void;
    render(): any;
}
