import { type EventEmitter } from '../../../stencil-public-runtime';
import type { OnAnswerGeneratedCallbackProps, OnSearchCompletedCallbackProps, Dictionary } from "../../../types/index";
import type { HighlightOptions } from '@orama/highlight';
export declare class OramaSearch {
    el: HTMLElement;
    placeholder?: string;
    focusInput?: boolean;
    suggestions?: string[];
    sourceBaseUrl?: string;
    linksTarget?: string;
    linksRel?: string;
    disableChat?: boolean;
    relatedQueries?: number;
    highlightTitle?: HighlightOptions | false;
    highlightDescription?: HighlightOptions | false;
    dictionary?: Partial<Dictionary>;
    selectedFacet: string;
    searchCompleted: EventEmitter<OnSearchCompletedCallbackProps>;
    answerGenerated: EventEmitter<OnAnswerGeneratedCallbackProps>;
    inputRef: HTMLOramaInputElement;
    private searchStore;
    private globalStore;
    private chatStore;
    /**
     * Gets the text for a specific key from the dictionary prop.
     * Prioritizes direct props (placeholder) for backward compatibility,
     * then falls back to the dictionary prop, and finally to the defaultTextDictionary.
     *
     * @param key - The key to get the text for
     * @returns The text for the specified key
     */
    getText(key: keyof Dictionary): string;
    doSearch(): void;
    handleSubmit: (e: Event) => void;
    render(): any;
}
