export interface TextProps {
    /** it defines the HTML tag to be used */
    as?: 'p' | 'h1' | 'h2' | 'h3' | 'h4' | 'h5' | 'h6' | 'span' | 'small' | 'a';
    /** it defines how it should look like */
    styledAs?: 'p' | 'span' | 'small' | undefined;
    /** the optional class name */
    class?: string;
    /** optionally change text alignment */
    align?: 'left' | 'center' | 'right';
    /** optionally change variant style - default is primary */
    variant: 'primary' | 'secondary' | 'tertiary';
    /** show as inactive */
    inactive?: boolean;
}
export declare class OramaText implements TextProps {
    el: HTMLElement;
    as?: TextProps['as'];
    styledAs?: TextProps['styledAs'];
    bold?: boolean;
    class?: string;
    align?: TextProps['align'];
    variant: TextProps['variant'];
    inactive?: TextProps['inactive'];
    render(): any;
}
