declare const theme: {
    typography: {
        '--font-primary': string;
    };
    colors: {
        gray50: string;
        gray100: string;
        gray200: string;
        gray300: string;
        gray400: string;
        gray500: string;
        gray600: string;
        gray700: string;
        gray800: string;
        gray900: string;
        gray950: string;
        purple100: string;
        purple200: string;
        purple300: string;
        purple500: string;
        purple600: string;
        purple700: string;
        light: {
            "--text-color-primary": string;
            "--text-color-secondary": string;
            "--text-color-tertiary": string;
            "--text-color-accent": string;
            "--text-color-inactive": string;
            "--text-color-reverse": string;
            "--background-color-primary": string;
            "--background-color-secondary": string;
            "--background-color-tertiary": string;
            "--background-color-fourth": string;
            "--background-color-reverse": string;
            "--background-color-accent": string;
            "--border-color-primary": string;
            "--border-color-secondary": string;
            "--border-color-tertiary": string;
            "--border-color-accent": string;
            "--icon-color-primary": string;
            "--icon-color-secondary": string;
            "--icon-color-tertiary": string;
            "--icon-color-inactive": string;
            "--icon-color-reverse": string;
            "--shadow-color-primary": string;
            "--button-text-color-primary": string;
            "--button-text-color-secondary": string;
            "--button-background-color-primary": string;
            "--button-background-color-secondary": string;
            "--button-background-color-secondary-hover": string;
            "--button-border-color-secondary": string;
            "--backdrop-background-color-primary": string;
            "--chat-button-border-color-gradientOne": string;
            "--chat-button-border-color-gradientTwo": string;
            "--chat-button-border-color-gradientThree": string;
            "--chat-button-border-color-gradientFour": string;
            "--chat-button-border-color-gradientFive": string;
            "--chat-button-border-color-gradientSix": string;
            "--chat-button-background-color-gradientOne": string;
            "--chat-button-background-color-gradientTwo": string;
        };
        dark: {
            "--text-color-primary": string;
            "--text-color-secondary": string;
            "--text-color-tertiary": string;
            "--text-color-accent": string;
            "--text-color-inactive": string;
            "--text-color-reverse": string;
            "--background-color-primary": string;
            "--background-color-secondary": string;
            "--background-color-tertiary": string;
            "--background-color-fourth": string;
            "--background-color-reverse": string;
            "--background-color-accent": string;
            "--border-color-primary": string;
            "--border-color-secondary": string;
            "--border-color-tertiary": string;
            "--border-color-accent": string;
            "--icon-color-primary": string;
            "--icon-color-secondary": string;
            "--icon-color-tertiary": string;
            "--icon-color-inactive": string;
            "--icon-color-reverse": string;
            "--shadow-color-primary": string;
            "--button-text-color-primary": string;
            "--button-text-color-secondary": string;
            "--button-background-color-primary": string;
            "--button-background-color-secondary": string;
            "--button-background-color-secondary-hover": string;
            "--button-border-color-secondary": string;
            "--backdrop-background-color-primary": string;
            "--chat-button-border-color-gradientOne": string;
            "--chat-button-border-color-gradientTwo": string;
            "--chat-button-border-color-gradientThree": string;
            "--chat-button-border-color-gradientFour": string;
            "--chat-button-border-color-gradientFive": string;
            "--chat-button-border-color-gradientSix": string;
            "--chat-button-background-color-gradientOne": string;
            "--chat-button-background-color-gradientTwo": string;
        };
    };
    radius: {
        '--radius-xs': string;
        '--radius-s': string;
        '--radius-m': string;
        '--radius-l': string;
        '--radius-3xl': string;
        '--textarea-radius': string;
    };
    shadow: {
        '--textarea-shadow': any;
    };
};
type TTheme = typeof theme;
type DeepPartial<T> = {
    [P in keyof T]?: T[P] extends object ? DeepPartial<T[P]> : T[P];
};
export type TThemeOverrides = DeepPartial<TTheme>;
export default theme;
