import type { OramaClient } from '@oramacloud/client';
import type { CollectionManager } from '@orama/core';
import type { AnyOrama } from '@orama/orama';
import { type OnAnswerGeneratedCallbackProps } from "../types/index";
import type { ChatStoreType } from "../ParentComponentStore/ChatStore";
export declare class ChatService {
    private answerSession;
    private client;
    private chatStore;
    constructor(oramaClient: OramaClient | AnyOrama, oramaCoreClient: CollectionManager, chatStore: ChatStoreType);
    private getSourcesMapObjectByIndexId;
    private getResultMapValue;
    sendQuestion: (term: string, relatedQueries?: number, systemPrompts?: string[], callbacks?: {
        onAnswerGeneratedCallback?: (onAnswerGeneratedCallback: OnAnswerGeneratedCallbackProps) => unknown;
    }) => Promise<void>;
    private askOramaCore;
    private askOramaCloud;
    abortAnswer: () => void;
    regenerateLatest: () => Promise<void>;
    resetChat: () => Promise<void>;
}
