import type { Dictionary } from "../types/index";
/**
 * Default text dictionary with standard text values for all components
 */
export declare const defaultTextDictionary: Dictionary;
/**
 * Gets the text for a specific key from the dictionary prop.
 * Prioritizes direct props (searchPlaceholder, chatPlaceholder) for backward compatibility,
 * then falls back to the dictionary prop, and finally to the defaultTextDictionary.
 *
 * @param key - The key to get the text for
 * @param dictionary - The custom text dictionary provided by the user
 * @param directProps - Optional direct props that take precedence (for backward compatibility)
 * @returns The text for the specified key
 */
export declare function getText(key: keyof Dictionary, dictionary?: Partial<Dictionary>, directProps?: Partial<Record<keyof Dictionary, string>>): string;
