import type { TThemeOverrides } from "../components";
import type { CloudIndexConfig, ColorScheme } from "../types/index";
import type { AnyOrama } from '@orama/orama';
import { OramaClient } from '@oramacloud/client';
import type { CollectionManager } from '@orama/core';
/**
 * Arrow keys navigation for focusable elements within a container
 *
 * @param ref HTMLElement - The element that contains the focusable elements
 * @param event KeyboardEvent - The event that triggered the navigation
 * @param selector string - The selector for the focusable elements (default: '[focus-on-arrow-nav]')
 * @returns void
 */
export declare function arrowKeysNavigation(ref: HTMLElement, event: KeyboardEvent, selector?: string): void;
export declare function format(first: string, middle: string, last: string): string;
export declare function copyToClipboard(text: any): void;
export declare function getNonExplicitAttributes(element: HTMLElement, explicitProps: string[]): {
    [key: string]: string;
};
export declare function validateCloudIndexConfig(el: HTMLElement, indexOrIndexes?: CloudIndexConfig | CloudIndexConfig[], instance?: OramaClient | AnyOrama | CollectionManager, oramaCoreInstance?: CollectionManager): void;
export declare function initOramaClient(indexOrIndexes: CloudIndexConfig | CloudIndexConfig[]): OramaClient | null;
export declare function generateRandomID(componentName: string): string;
export declare function updateThemeClasses(element: HTMLElement, colorScheme: ColorScheme, systemScheme: Omit<ColorScheme, 'system'>): "dark" | "light" | Omit<ColorScheme, "system">;
export declare function updateCssVariables(element: HTMLElement, scheme: ColorScheme, themeConfig?: Partial<TThemeOverrides>): void;
